/***

KameleonDUI - DUI-Component.m
by Leechbite

script to control the DUI interfaces of component windows.

***/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"
#include "dui-utilities.m"

#define SKINTWEAKS_CFGPAGE "{0542AFA4-48D9-4c9f-8900-5739D52C114F}"

function disablePSOVC();
function enablePSOVC();

function requestOpen();
function requestClose();

function setToDUIMode();
function resetFromDUIMode();

function syncWndHlr();

function toggleComponent(string compID);

global container duiMainContainer;
global layout duiMainLayout;
global group duiMainGroup;
global guiObject duiMainWin, duiMainObjCont;
global WindowHolder duiCompHolder;

Global String duix, duiy, duiw, duih;
Global string duimin_w, duimin_h, duimax_w, duimax_h;
Global String windowName, guid, groupid, duiWindow, defDuiWindow, contName;
global string duiWndHlrID;
global int duiWndHlr_x, duiWndHlr_y, duiWndHlr_w, duiWndHlr_h;
global int localOpen = FALSE, openLastResizeHide = FALSE;

global ConfigAttribute currwindow_attach_attrib, currwindow_duiwindow_attrib; //, currwindow_tempdetach_attrib;

global button attachButton,detachButton,windowButton,closeButton;

global timer onStartTimer, delayOpen, delayClose, removeLocalOpen, delayToDUI, delayRequestOpen, PSOVCTimer;

System.onScriptLoaded() {
	initAttribs();
	
	string param = getParam();
	windowName = getToken(param,",",0);
	guid = getToken(param,",",1);
	groupid = getToken(param,",",2);
	defDuiWindow = strlower(getToken(param, ",", 3));
	duiWindow = defDuiWindow;
	
	setPrivateString(getSkinName(),"Def DUI:"+windowName,defDuiWindow);
	
	duimin_w = getToken(param,",",4);
	duimin_h = getToken(param,",",5);
	duimax_w = getToken(param,",",6);
	duimax_h = getToken(param,",",7);
	contName = getToken(param,",",8);
	
	duiWndHlrID = getToken(param,",",9);
	duiWndHlr_x = stringToInteger(getToken(param,",",10));
	duiWndHlr_y = stringToInteger(getToken(param,",",11));
	duiWndHlr_w = stringToInteger(getToken(param,",",12));
	duiWndHlr_h = stringToInteger(getToken(param,",",13));
	
	//sendDUICommand(windowName, ADD_TO_DUI_LIST, "");
	currwindow_attach_attrib = custom_page_windows.newAttribute("Attach "+windowName+" window", "1");
	currwindow_duiwindow_attrib = custom_page_nonexposed.newAttribute("DUI window "+windowName, defDuiWindow);
	duiWindow = currwindow_duiwindow_attrib.getData();

	
	onStartTimer = new Timer;
	onStartTimer.setDelay(1);
	onStartTimer.start();
	
	delayOpen = new Timer;
	delayOpen.setDelay(100);
	
	delayClose = new Timer;
	delayClose.setDelay(1);
	
	delayToDUI = new Timer;
	delayToDUI.setDelay(100);
	
	delayRequestOpen = new Timer;
	delayRequestOpen.setDelay(150);
	
	removeLocalOpen = new Timer;
	removeLocalOpen.setDelay(150);
	
	PSOVCTimer = new Timer;
	PSOVCTimer.setDelay(1000);

}
// **** DUI scripts
system.onScriptUnloading() {
	delete onStartTimer;
	delete delayClose;
	delete delayOpen;
	delete delayToDUI;
	delete delayRequestOpen;
	delete removeLocalOpen;
	delete PSOVCTimer;
	
	if (dui_temp_detach_attrib.getData()=="0") {
		if (duiMainObjCont) 
			setPrivateInt(getSkinName(),"OpenOnLastDUI "+windowName,(duiMainObjCont.getXMLParam("groupid") == groupid)); // show on skin load
		else
			setPrivateInt(getSkinName(),"OpenOnLastDUI "+windowName,0);
	}

}

onStartTimer.onTimer() {
	stop();

	sendDUICommand(windowName, ADD_TO_DUI_LIST, "");
	
	if (dui_temp_detach_attrib.getData()=="0") {
		if (getPrivateInt(getSkinName(),"OpenOnLastDUI "+windowName,0)==1) currwindow_attach_attrib.onDataChanged();
		setPrivateInt(getSkinName(),"OpenOnLastDUI "+windowName,0);
	}
	
}

// copied from drawer.m of Winamp Modern
disablePSOVC() {

    ConfigItem item = Config.getItem(SKINTWEAKS_CFGPAGE);
    if (item) {
        ConfigAttribute attr = item.getAttribute("Prevent video playback Stop on video window Close");
        if (attr) attr.setData("1");
    }
    PSOVCTimer.start();
}

enablePSOVC() {

    PSOVCTimer.stop();
    ConfigItem item = Config.getItem(SKINTWEAKS_CFGPAGE);
    if (item) {
        ConfigAttribute attr = item.getAttribute("Prevent video playback Stop on video window Close");
        if (attr) attr.setData("0");
    }
}

PSOVCTimer.onTimer() {
    enablePSOVC();
}

system.onGetCancelComponent(String curguid, boolean goingvisible) {
	
	if (curguid!= guid) return;
	
	if (localOpen) { return FALSE; }

	if (goingvisible) {
		if (currwindow_attach_attrib) {
			if ((currwindow_attach_attrib.getData()!="1") || (dui_temp_detach_attrib.getData()=="1")) {
				
				return FALSE;
			} else {
				if (!delayClose.isRunning()) requestOpen(); // if in middle of closing, then don't open 
				
				return TRUE;
			}
		}
	} else {
		if (currwindow_attach_attrib) {
			if ((currwindow_attach_attrib.getData()!="1") || (dui_temp_detach_attrib.getData()=="1"))
				return FALSE;
			else {
				if (!delayToDUI.isRunning()) requestClose(); //check to delaytodui to prevent rebounce on winamp start-up
				return FALSE;
			}
		}
	}
	
	return TRUE;
}

requestOpen() {
	openLastResizeHide = FALSE;
	
	if (dui_temp_detach_attrib.getData()=="1") {
		setPrivateInt(getSkinName(),"OpenOnLastDUI "+windowName,1);
		return;
	}
	
	duiWindow = currwindow_duiwindow_attrib.getData();
	
	int iduimin_w = stringToInteger(duimin_w);
	int iduimin_h = stringToInteger(duimin_h);
	int defw = getPrivateInt(getSkinName(),"duidefW "+windowName,iduimin_w);
	int defh = getPrivateInt(getSkinName(),"duidefH "+windowName,iduimin_h);
	if (defw < iduimin_w) defw = iduimin_w; // just check for min, this is just for contengency
	if (defh < iduimin_h) defh = iduimin_h;
	
	sendDUICommand(windowName, OPEN_DUI_REQUEST, duiWindow+","+duimin_w+","+duimin_h+","+duimax_w+","+duimax_h+","+
							integerToString(defw)+","+integerToString(defh));
}

requestClose() {
	sendDUICommand(windowName, CLOSE_DUI_WINDOW, duiWindow);
	
	duiMainContainer = NULL;
	duiMainLayout = NULL;
	duiMainGroup = NULL;
	duiMainGroup = NULL;
	duiMainWin = NULL;

	if (delayRequestOpen.isRunning()) delayRequestOpen.stop();
	if (delayOpen.isRunning()) delayOpen.stop();
	delayClose.start();
}

delayClose.onTimer() {
	if (isRunning()) stop();
	
	if (duiMainObjCont) {
		if (duiMainObjCont.getXMLParam("groupid") == groupid) duiMainObjCont.setXMLParam("groupid","dui.empty");
	}
	
	if (duiCompHolder) {
		localOpen = TRUE;
		duiCompHolder.hide();

		removeLocalOpen.start();
	}
	
	duiMainObjCont = NULL;
	duiCompHolder = NULL;
}

currwindow_attach_attrib.onDataChanged() {
	if (guid==VID_GUID) disablePSOVC();

	if (getData()=="1") {
		if (isNamedWindowVisible(guid) || (getPrivateInt(getSkinName(),"OpenOnLastDUI "+windowName,0)==1)) {
			if (contName!="") { // hideNamedWindow does not work on all guids 
				container closecont = NULL;
				closecont = getContainer(contName);
							
				if (closecont) { closecont.close();  }
			} else {
				hideNamedWindow(guid);
			}

			if (!isNamedWindowVisible(guid)) requestOpen();
		}
	} else {
		if (duiMainObjCont) {
			if (duiMainObjCont.getXMLParam("groupid") == groupid) {
				string nextcomp = getPrivateString(getSkinName(),strupper(windowName)+" Next Window","");
				if ((windows_duitab_attrib.getData()=="1") && (nextcomp!="") && (dui_temp_detach_attrib.getData()!="1") && (dui_onresizehide_attrib.getData()=="0")) {
					toggleComponent(nextcomp);
				} else
					requestClose();
					
				delayOpen.start();
			}
		}
	}
}

delayOpen.onTimer() {
	stop();

	showWindow(guid,"",0);
	if (guid==VID_GUID) enablePSOVC();
}

attachButton.onLeftClick() {
	if (currwindow_attach_attrib) currwindow_attach_attrib.setData("1");
}

detachButton.onLeftClick() {
	if (currwindow_attach_attrib) currwindow_attach_attrib.setData("0");
}

closeButton.onLeftClick() {
	requestClose();
}

windowButton.onLeftClick() {
	if (!currwindow_duiwindow_attrib) return;
	
	popupMenu DUIwindowMenu;
	
	string currDUIWin = currwindow_duiwindow_attrib.getData();
	
	DUIwindowMenu = new popupMenu;
	DUIwindowMenu.addCommand("- Select DUI Window -", -1, 0, 1);
	DUIwindowMenu.addSeparator();
	DUIwindowMenu.addCommand(" Main", 1, currDUIWin==DUI_WIN_MAIN, 0);
	DUIwindowMenu.addCommand(" Bottom Main", 2, currDUIWin==DUI_WIN_MAIN2, 0);
	DUIwindowMenu.addCommand(" Side", 3, currDUIWin==DUI_WIN_SIDE, 0);
	DUIwindowMenu.addCommand(" Top Side", 4, currDUIWin==DUI_WIN_SIDE2, 0);
	DUIwindowMenu.addSeparator();
	DUIwindowMenu.addCommand(" Reset to default", 5, 0, 0);
	
	string lastTip = getXMLParam("tooltip");
	setXMLParam("tooltip", "");

  	int res = DUIwindowMenu.popAtMouse();
  	delete DUIwindowMenu;
  	
  	if (res == 1) currwindow_duiwindow_attrib.setData(DUI_WIN_MAIN);
  	if (res == 2) currwindow_duiwindow_attrib.setData(DUI_WIN_MAIN2);
  	if (res == 3) currwindow_duiwindow_attrib.setData(DUI_WIN_SIDE);
  	if (res == 4) currwindow_duiwindow_attrib.setData(DUI_WIN_SIDE2);
  	if (res == 5) currwindow_duiwindow_attrib.setData(defDuiWindow);
  	
  	setXMLParam("tooltip", lastTip);
}

currwindow_duiwindow_attrib.onDataChanged() {
	string lastDUIWindow = duiWindow;
	duiWindow = getData();
	
	if (lastDUIWindow == duiWindow) return;
	if (!currwindow_duiwindow_attrib) return;
	if (!duiMainObjCont) return;
	if (duiMainObjCont.getXMLParam("groupid") != groupid) return;

	string nextcomp = getPrivateString(getSkinName(),strupper(windowName)+" Next Window","");
	if (guid==VID_GUID) disablePSOVC();
	
	if ((windows_duitab_attrib.getData()=="1") && (nextcomp!="")) {
		toggleComponent(nextcomp);
	} else
		sendDUICommand(windowName, CLOSE_DUI_WINDOW, lastDUIWindow);
		
	delayRequestOpen.start();
}

duiMainContainer.onBeforeSwitchToLayout(Layout oldlayout, Layout newlayout) {
	if (guid==VID_GUID) disablePSOVC();
}

dui_temp_detach_attrib.onDataChanged() {
	if (!currwindow_attach_attrib) return;

	if (currwindow_attach_attrib.getData()=="0") {  // if not attached, dont bother to detach
		setPrivateInt(getSkinName(),"OpenOnLastDUI "+windowName,0);
		return;
	}

	if (getData()=="0") {
		currwindow_attach_attrib.onDataChanged(); // reattach
	} else {
		setPrivateInt(getSkinName(),"OpenOnLastDUI "+windowName,0);
		if (duiMainObjCont) {
			if (duiMainObjCont.getXMLParam("groupid") == groupid) { // check if guid on dui window
				requestClose(); // close dui window
				
				if ((windows_detachonshade_attrib.getData()=="1") && (dui_onresizehide_attrib.getData()=="0")) // open detached window	
					delayOpen.start();
				else
					setPrivateInt(getSkinName(),"OpenOnLastDUI "+windowName,1);

			}
		}
	}
}

dui_onresizehide_attrib.onDataChanged() {
	if (getData()=="1") {
		openLastResizeHide = FALSE;
		if (duiMainObjCont) {
			if (duiMainObjCont.getXMLParam("groupid") == groupid) {
				delayClose.start();
				openLastResizeHide = TRUE;
			}
		}
	} else {
		string lowDUIWin = strlower(currwindow_duiwindow_attrib.getData());
		if ((strlower(getPrivateString(getSkinName(),"onDUIClosing",""))!=lowDUIWin) && openLastResizeHide) {
			delayOpen.start();
		}


		openLastResizeHide = FALSE;
	}
	
}

delayRequestOpen.onTimer() {
	stop();

	requestOpen();
}

onReceiveDUICommand(string winName, string command, string param) {
	string lowWinName = strlower(winName);
	string lowWinName2 = strlower(windowName);
	if (lowWinName == lowWinName2) return;
	
	string param1 = strlower(gettoken(param,",",0));
	
	if (winName == MAINID) {
	
		if (command == OPEN_DUI_GRANTED) {

		  if (currwindow_attach_attrib) { 
			  if ((currwindow_attach_attrib.getData()=="0") && (dui_temp_detach_attrib.getData()=="0")) return; }
			  
		  if (param1 == "all") param1 = strlower(windowName);
		  if (param1 == strlower(windowName)) {

		    string duiContainerID = strlower(gettoken(param,",",1));
		    string duiLayoutID = strlower(gettoken(param,",",2));
		    string duiGroupID = strlower(gettoken(param,",",3));
		    string duiWinID = strlower(gettoken(param,",",4));
		    
		    duiMainContainer = getContainer(duiContainerID);
		    if (duiMainContainer) duiMainLayout = duiMainContainer.getLayout(duiLayoutID);
		    if (duiMainLayout) duiMainGroup = duiMainLayout.findObject(duiGroupID);
		    if (duiMainGroup) duiMainWin = duiMainGroup.findObject(duiWinID);
		    if (duiMainGroup) duiMainObjCont = duiMainGroup.findObject("obj.container");
		    if (duiMainLayout) duiCompHolder = duiMainLayout.findObject(duiWndHlrID);
		    if (duiMainObjCont) duiMainObjCont.show();
		    if (duiMainWin) duiMainWin.hide();
		    //if (duiCompHolder) duiCompHolder.hide();
		    
		    delayToDUI.start();
		    
		  }
		} else if (command == DETACH_WINDOW_GRANTED) {
		  if (param1 == "all") param1 = strlower(windowName);
		  if (param1 == strlower(windowName)) {
		    resetFromDUIMode();
		  }
		} else if (command == CLOSE_DUI_WINDOW) {
			if (param1 == "all") param1 = strlower(windowName);

			if (param1 == strlower(windowName)) {
				if (duiMainObjCont) {
					delayClose.start();
				}
			}
		}
	}
}

// triggered on refresh layout
dui_on_transition_attrib.onDataChanged() {
	if (getData() == "0") syncWndHlr();
}

duiMainWin.onResize(int wx, int wy, int ww, int wh) {
	syncWndHlr();
}

syncWndHlr() {
	if (dui_on_transition_attrib.getData() == "1") return;
	if (!duiMainGroup) return;
	if (!duiCompHolder) return;
	if (duiMainObjCont.getXMLParam("groupid") != groupid) return;
	if ((currwindow_attach_attrib.getData()!="1") || (dui_temp_detach_attrib.getData()=="1")) return;
	
	group groupParent = duiCompHolder.getParent();
	
	int x = duiMainWin.getLeft() + duiWndHlr_x - groupParent.getLeft();
	int y = duiMainWin.getTop() + duiWndHlr_y - groupParent.getTop();
	int w = duiMainWin.getWidth() + duiWndHlr_w;
	int h = duiMainWin.getHeight() + duiWndHlr_h;
	
	duiCompHolder.setXMLParam("x", integerToString(x));
	duiCompHolder.setXMLParam("y", integerToString(y));
	duiCompHolder.setXMLParam("w", integerToString(w));
	duiCompHolder.setXMLParam("h", integerToString(h));
	duiCompHolder.setXMLParam("relatx", "0");
	duiCompHolder.setXMLParam("relaty", "0");
	duiCompHolder.setXMLParam("relatw", "0");
	duiCompHolder.setXMLParam("relath", "0");
	
	setPrivateInt(getSkinName(),"duidefW "+windowName,duiMainWin.getWidth());
	setPrivateInt(getSkinName(),"duidefH "+windowName,duiMainWin.getHeight());
}

delayToDUI.onTimer() {
	stop();
	
	setToDUIMode();
}

setToDUIMode() {
	if (!duiMainObjCont) return;
	
	duiMainObjCont.setXMLParam("groupid",groupid);
	
	detachButton = duiMainObjCont.findObject("dui.detach");
	windowButton = duiMainObjCont.findObject("dui.window");
	closeButton = duiMainObjCont.findObject("dui.close2");
	
	if (duiCompHolder) {
		localOpen = TRUE;
		syncWndHlr();
		
		// very important! otherwise AVS wont work. this makes sure the guid is not lurking somewhere. 
		//if (isNamedWindowVisible(guid)) hideNamedWindow(guid); 
		
		duiCompHolder.show();
		removeLocalOpen.start();

	}
}

resetFromDUIMode() {
	if (duiMainObjCont.getXMLParam("groupid") == groupid) {
		localOpen = TRUE;
		//duiMainObjCont.setXMLParam("groupid","");
		removeLocalOpen.start();
	}
	
	duiMainContainer = NULL;
	duiMainLayout = NULL;
	duiMainGroup = NULL;
	duiMainGroup = NULL;
	duiMainObjCont = NULL;
	duiMainWin = NULL;
}

removeLocalOpen.onTimer() {
	if (isRunning()) stop();
	localOpen = FALSE;
}

toggleComponent(string compID) {
	layout mainLayout = getContainer("main").getLayout("normal");
	
	if (compID=="PL") {
		triggerAction(mainLayout,"TOGGLE","guid:pl");
	} else if (compID=="ML") {
		triggerAction(mainLayout,"TOGGLE","guid:ml");
	} else if (compID=="VID") {
		triggerAction(mainLayout,"TOGGLE","guid:{F0816D7B-FFFC-4343-80F2-E8199AA15CC3}");
	} else if (compID=="VIS") {
		triggerAction(mainLayout,"TOGGLE","guid:avs");
	} else if (compID=="EQ") {
		triggerAction(mainLayout,"TOGGLE","eq");
	} else if (compID=="IE") {
		triggerAction(mainLayout,"TOGGLE","ibrowser");
	} else if (compID=="CD") {
		triggerAction(mainLayout,"TOGGLE","cdcover");
	} else if (compID=="CP") {
		triggerAction(mainLayout,"TOGGLE","Config");
	}
}
