/*** 

	DUI-Utilities.m - common functions used by DUI scripts.

***/

#ifndef __ATTRIBS_M
#error This script requires attribs.m to be included
#endif

#define OPEN_DUI_GRANTED "open_dui_granted"
#define OPEN_DUI_REQUEST "open_dui_request"
#define DETACH_WINDOW_REQUEST "detach_win_request"
#define DETACH_WINDOW_GRANTED "detach_win_granted"
#define CLOSE_DUI_WINDOW "close"
#define ADD_TO_DUI_LIST "add_to_list"
#define SET_FOCUS "set_focus"
#define REQUEST_RESIZE "request_resize"
// the following dui-commands are not used, 
// but for some reason i dont want to remove them. :D
#define TEMP_DETACH "temp_detach"
#define RESTORE_TEMP_DETACH "restore_temp_detach"
#define TRANSFER_DUI_WINDOW "transfer_dui_window"

#define MAINID "main"

#define DUI_WIN_MAIN "dui_main"
#define DUI_WIN_MAIN2 "dui_main2"
#define DUI_WIN_SIDE "dui_side"
#define DUI_WIN_SIDE2 "dui_side2"

function sendDUICommand(string windowName, string command, string param);
function onReceiveDUICommand(string windowName, string command, string param); // Hookable. Triggered when a DUI Command is sent

sendDUICommand(string windowName, string command, string param) {

  command = strlower(command);
  dui_comm_attrib.setData(windowName+"~"+command+"~"+param);
 
}

dui_comm_attrib.onDataChanged() {
  string _winName = getToken(getData(),"~",0);
  string _comm = getToken(getData(),"~",1);
  string _param = getToken(getData(),"~",2);
  
  onReceiveDUICommand(_winName, _comm, _param);

}

onReceiveDUICommand(string windowName, string command, string param) { } // Hookable