// ******* KameleonDUI - About.m **********

#include <lib/std.mi>
#include "attribs.m"

class text menuText;

Global group aboutGroup;
Global layer base,basewhite, credits;
Global guiObject rectbase;
Global menuText menuLeechbite, menuWinamp, menuUpdate, menuCredits;
Global text menuShadow;
Global timer creditTimer;

Global group updateGroup;
Global browser updateBrowser;
Global text updateText;
Global timer updateTimer;
Global string latestversion="";

Global int currcolor;
Global double smidge;

System.onScriptLoaded() {
	aboutGroup = getScriptGroup();
	
	rectbase = aboutGroup.getObject("about.base.color");
	currcolor = 765;

	base = aboutGroup.getObject("about.base");
	base.fx_setWrap(1);
	base.fx_setBilinear(1);
	base.fx_setAlphaMode(0);
	base.fx_setGridSize(10, 10);
	base.fx_setRect(1);
	base.fx_setClear(1);
	base.fx_setLocalized(1);
	base.fx_setRealtime(1);
	base.fx_setSpeed(50);
	base.fx_setEnabled(1);
	
	basewhite = aboutGroup.getObject("about.base.white");
	menuLeechbite = aboutGroup.getObject("about.menu.leechbite");
	menuWinamp = aboutGroup.getObject("about.menu.winamp");
	menuUpdate = aboutGroup.getObject("about.menu.update");
	menuCredits = aboutGroup.getObject("about.menu.credits");
	menuShadow = aboutGroup.getObject("about.menu.shadow");
	credits = aboutGroup.getObject("about.credits");
	
	updateGroup = aboutGroup.getObject("skin.about.updatecheck"); 
	updateBrowser = updateGroup.getObject("browser.updatecheck");
	updateText = updateGroup.getObject("update.message");
	updateGroup.hide();
	
	creditTimer = new Timer;
	creditTimer.setDelay(8000);
	
	updateTimer = new Timer;
	updateTimer.setDelay(15000);
	aboutGroup.onSetVisible(1);
}

system.onScriptUnloading() {
	delete creditTimer;
	delete updateTimer;
	aboutGroup = NULL; // clears all instances
}

base.fx_onGetPixelX(double r, double d, double x, double y) {
	return x*cos(smidge*4+y*6.28318)*0.99;
	
}

base.fx_onGetPixelY(double r, double d, double x, double y){
	return y*cos(smidge+r*0.05);
}

base.fx_onFrame() {
	
	smidge += 0.0069813;
	if (smidge >=6.28318) smidge = 0;
	
	currcolor++;
	if (currcolor > 1020) currcolor = 0;
	int r,g,b;
	
	if (currcolor <= 255) {
		r = 255 - currcolor;
		g = currcolor;
		b = 0;
	} else if (currcolor <= 510) {
		r = 0;
		g = 510 - currcolor;
		b = currcolor - 255;
	} else if (currcolor <= 765) {
		r = (currcolor - 510)*160/255;
		g = (currcolor - 510)*160/255;
		b = 255-(currcolor - 510)*95/255;
	} else if (currcolor <= 1020) {
		r = 160+(currcolor-765)*95/255;
		g = 160-(currcolor-765)*160/255;
		b = 160-(currcolor-765)*160/255;
	}
	rectbase.setXMLParam("color",integertostring(r)+","+integertostring(g)+","+integertostring(b));
}

aboutGroup.onSetVisible(boolean on) {
	if (on) {
		
		menuLeechbite.cancelTarget();
		menuWinamp.cancelTarget();
		menuUpdate.cancelTarget();
		menuCredits.cancelTarget();
		menuLeechbite.setXMLParam("x","0");
		menuWinamp.setXMLParam("x","0");
		menuUpdate.setXMLParam("x","0");
		menuCredits.setXMLParam("x","0");
		
		basewhite.cancelTarget();
		basewhite.setAlpha(0);
		basewhite.setXMLParam("x","0");
		basewhite.setTargetSpeed(1.0);
		basewhite.setTargetX(-96);
		basewhite.setTargetA(255);
		basewhite.gotoTarget();
	}
}

basewhite.onTargetReached() {
	menuLeechbite.setTargetSpeed(0.5);
	menuWinamp.setTargetSpeed(0.5);
	menuUpdate.setTargetSpeed(0.5);
	menuCredits.setTargetSpeed(0.5);
	menuLeechbite.setTargetX(-152);
	menuWinamp.setTargetX(-132);
	menuUpdate.setTargetX(-152);
	menuCredits.setTargetX(-137);
	
	menuLeechbite.gotoTarget();
	
}

menuLeechbite.onTargetReached() { menuWinamp.gotoTarget(); }
menuWinamp.onTargetReached() { menuCredits.gotoTarget(); }
menuCredits.onTargetReached() { menuUpdate.gotoTarget(); }

menuText.onEnterArea() {
	setXMLParam("fontsize","24");
	menuShadow.setText(getText());
}

menuText.onLeaveArea() {
	setXMLParam("fontsize","18");
	menuShadow.setText("");
}

menuLeechbite.onLeftButtonDown(int x, int y) {
	navigateURL("http://www.leechbite.com/");
}

menuWinamp.onLeftButtonDown(int x, int y) {
	navigateURL("http://www.winamp.com/");
}

menuCredits.onLeftButtonDown(int x, int y) {
	updateTimer.onTimer();
	
	credits.cancelTarget();
	credits.setTargetX(55);
	credits.setTargetSpeed(1.0);
	credits.gotoTarget();
	creditTimer.start();
}

creditTimer.onTimer() {
	stop();
	
	credits.cancelTarget();
	credits.setTargetX(-160);
	credits.setTargetSpeed(1.0);
	credits.gotoTarget();
	creditTimer.start();
}

menuUpdate.onLeftButtonDown(int x, int y) {
	creditTimer.onTimer();
	
	updateGroup.show();
	updateBrowser.navigateUrl("http://kameleondui.leechbite.com/updatecheck.php?"+SKIN_VERSION);
	updateText.setText("Checking for a new version...");
	
	updateTimer.start();
}

updateTimer.onTimer() {
	stop();
	
	updateGroup.hide();
}

updateBrowser.onDocumentComplete(String strurl) {
	int res = System.strSearch(strURL, "newversion.html");
	int res2 = System.strSearch(strURL, "current.html");
	if (res > -1) {
		latestversion = strright(strURL, strlen(strURL) - strsearch(strURL,"?") - 1);
		updateText.setText("KameleonDUI "+latestversion+" available now! Click to download.");
	} else if (res2 > -1) {
		updateText.setText("Your skin is current.");
	}
}

updateText.onLeftButtonDown(int x, int y) {
	updateTimer.onTimer();
	
	if (latestversion=="") return;
	
	system.navigateURL("http://kameleondui.leechbite.com/update.php");
}
