/*************************************************************

  KameleonDUI - bal-slider.m
  by Leechbite

  - this script controls the balance slider.

  param="totalWidth"
     totalWidth (int) - lenght of slider.
*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

#define PREAMP 10

Global group frameGroup;
Global guiObject leftSlider, rightSlider, mouseTrap;
Global slider realSlider;
Global int orgLeftX, orgLeftW, orgRightW, notemptext;
Global boolean mouseDown;

System.onScriptLoaded() {

	initAttribs();
	
	frameGroup = getScriptGroup();
	
	leftSlider = frameGroup.findObject("bal.slider.left");
	rightSlider = frameGroup.findObject("bal.slider.right");
	mouseTrap = frameGroup.findObject("bal.mousetrap");
	realSlider = frameGroup.findObject("bal.slider");
	
	orgLeftX = stringToInteger(leftSlider.getXMLParam("x"));
	orgLeftW = stringToInteger(leftSlider.getXMLParam("w"));
	orgRightW = stringToInteger(rightSlider.getXMLParam("w"));
	
	notemptext = 1;
	realSlider.onSetPosition(realSlider.getPosition());
	
}

System.onScriptUnLoading() {
	return;
}

realSlider.onSetPosition(int newpos) {
	int wid;
	
	if (newpos <= 128) {
		
		wid = (128-newpos)*orgLeftW/128;
		
		leftSlider.setXMLParam("x",integerToString(orgLeftX+orgLeftW-wid));
		leftSlider.setXMLParam("w",integerToString(wid));
		rightSlider.setXMLParam("w","1");

		if (!notemptext) {
			if (newpos == 128)
				setTempText("CENTER|BALANCE");
			else
				setTempText("LEFT: "+integerToString((128-newpos)*100/128)+"%|BALANCE");
		}
	} else {
		wid = (newpos-128)*orgRightW/127;
		
		leftSlider.setXMLParam("x",integerToString(orgLeftX+orgLeftW-1));
		leftSlider.setXMLParam("w","1");
		rightSlider.setXMLParam("w",integerToString(wid));
		
		if (!notemptext) setTempText("RIGHT: "+integerToString((newpos-128)*100/127)+"%|BALANCE");
	}
	notemptext = 0;
}

mouseTrap.onLeftButtonDown(int x, int y) {
	mouseDown = true;
	
	int newpos = (x-getLeft())*255/getWidth();
	if (newpos > 120 && newpos < 140) newpos = 128;
	
	realSlider.setPosition(newpos);
}

mouseTrap.onMouseMove(int x, int y) {
	if (!mouseDown) return;
	
	int newpos = (x-getLeft())*255/getWidth();
	if (newpos > 118 && newpos < 138) newpos = 128;
	
	realSlider.setPosition(newpos);
}

mouseTrap.onLeftButtonUp(int x, int y) {
	mouseDown = false;
}