/*************************************************************

  cdcover.m
  by Leechbite

  script for CDCover Container

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

function updateAlbumTitle();

Global layout cdcover;
Global group scriptGroup,contentGroup;
Global layer cdCover, noCover, reflectCover,reflectGradient, resizer;
Global AlbumArtLayer waCDCover, waReflectCover;
Global guiObject rating, shadow;
Global text txtalbuminfo;
//Global string last_autotitle;

Global double dblSmidge,dblSmidge2;

System.onScriptLoaded() {
	initAttribs();
	
	scriptGroup = getScriptGroup();

	contentGroup = scriptGroup.findObject("kameleon.xui.cdcover");
	noCover = contentGroup.findObject("xui.nocover");
	cdCover = contentGroup.findObject("xui.cdcover");
	waCDCover = contentGroup.findObject("xui.wa.cdcover");
	rating = scriptGroup.findObject("cdcover.rating");
	txtalbuminfo = scriptGroup.findObject("cdcover.text.albuminfo");
	reflectCover = scriptGroup.findObject("cdcover.reflection");
	waReflectCover = scriptGroup.findObject("wa.cdcover.reflection");
	reflectGradient = scriptGroup.findObject("cdcover.reflection.gradient");
	shadow = scriptGroup.findObject("cdcover.shadow");
	resizer = scriptGroup.findObject("cdcover.resizer");
	
	reflectCover.fx_setGridSize(10,10);
	reflectCover.fx_setBgFx(0);
	reflectCover.fx_setWrap(1);
	reflectCover.fx_setBilinear(1);
	reflectCover.fx_setRect(1);
	reflectCover.fx_setClear(0);
	reflectCover.fx_setLocalized(1);
	reflectCover.fx_setSpeed(1000);
	reflectCover.fx_setRealtime(0);
	reflectCover.fx_setEnabled(1);
	
	waReflectCover.fx_setGridSize(10,10);
	waReflectCover.fx_setBgFx(0);
	waReflectCover.fx_setWrap(1);
	waReflectCover.fx_setBilinear(1);
	waReflectCover.fx_setRect(1);
	waReflectCover.fx_setClear(0);
	waReflectCover.fx_setLocalized(1);
	waReflectCover.fx_setSpeed(1000);
	waReflectCover.fx_setRealtime(0);
	waReflectCover.fx_setEnabled(1);
	
	updateAlbumTitle();
	
	cdcover_coverfname_attrib.onDataChanged();
}

system.onScriptUnloading() {
	scriptGroup = NULL;
	noCover = NULL;
	cdCover = NULL;
}

system.onTitleChange(string newtitle) {
	//if (last_autotitle == newtitle) return;
	if (StrLeft(newtitle, 1) == "[") {
		if (StrLeft(newtitle, 7) == "[Buffer" || StrLeft(newtitle, 4) == "[ICY") return;
	}
	//last_autotitle = newtitle;
	
	updateAlbumTitle();
}

system.onPlay() {
	updateAlbumTitle();
}

system.onResume() {
	updateAlbumTitle();
}

updateAlbumTitle() {
	string albumstr = System.getPlayitemMetaDataString("album");
	string yearstr = System.getPlayitemMetaDataString("year");
	
	if (albumstr == "") albumstr = "unknown";
	if (yearstr != "") 
		albumstr = albumstr + " ("+yearstr+")";
		
	cdcover_cdinfo_attrib.setData(albumstr);
}

contentGroup.onResize(int x, int y, int w, int h) {
	if (getPrivateInt("KameleonDUI","nocdupdate",0)==1) return;
	
	int rateY = 0;
	int reflY = 0;
	int reflX = 0;
	int reflW = 0;
	int reflH = 0;

	if (cdcover_coverfname_attrib.getData()=="def") {
		
		rateY = getGuiY() + waCDCover.getGuiY();
		
		reflX = waCDCover.getGuiX()+getGuiX();
		reflY = rateY+waCDCover.getHeight();
		reflW = waCDCover.getWidth();
		reflH = waCDCover.getHeight()/2;
	} else if (cdcover_coverfname_attrib.getData()!="blank") {
		
		rateY = getGuiY() + cdcover.getGuiY();
		
		reflX = cdcover.getGuiX()+getGuiX();
		reflY = rateY+cdcover.getHeight();
		reflW = cdcover.getWidth();
		reflH = cdcover.getHeight()/2;
	} else {
		rateY = getGuiY() + noCover.getGuiY();
		
		reflX = noCover.getGuiX()+getGuiX();
		reflY = rateY+noCover.getHeight();
		reflW = noCover.getWidth();
		reflH = noCover.getHeight()/2;
		

	}
	
	resizer.setXMLParam("x", integerToString(reflX + reflW - 15));
	resizer.setXMLParam("y", integerToString(reflY - 15));
	
	rating.setXMLParam("y", integerToString(rateY-15));
	txtalbuminfo.setXMLParam("y", integerToString(rateY-30));
	
	if (cdcover_coverfname_attrib.getData()=="def") {
		waReflectCover.setXMLParam("h", integerToString(reflH));
		waReflectCover.setXMLParam("w", integerToString(reflW));
		waReflectCover.setXMLParam("x", integerToString(reflX));
		waReflectCover.setXMLParam("y", integerToString(reflY));
	} else {
		reflectCover.setXMLParam("x", integerToString(reflX));
		reflectCover.setXMLParam("y", integerToString(reflY));
		reflectCover.setXMLParam("w", integerToString(reflW));
		reflectCover.setXMLParam("h", integerToString(reflH));
	}
	
	reflectGradient.setXMLParam("x", integerToString(reflX));
	reflectGradient.setXMLParam("y", integerToString(reflY));
	reflectGradient.setXMLParam("w", integerToString(reflW));
	reflectGradient.setXMLParam("h", integerToString(reflH));
	
	shadow.setXMLParam("x", integerToString(reflX-(reflW*0.1)));
	shadow.setXMLParam("y", integerToString(reflY-reflH*0.05));
	shadow.setXMLParam("w", integerToString(reflW+(reflW*0.2)));
	shadow.setXMLParam("h", integerToString(reflH*0.1));
}

cdcover_coverfname_attrib.onDataChanged() {
	
	if (getData()=="def") {
		wareflectCover.fx_setEnabled(0);
		
		waReflectCover.show();
		waReflectCover.refresh();
		reflectCover.hide();
		
		waReflectCover.fx_setEnabled(1);
		waReflectCover.fx_restart();
	} else {
		reflectCover.fx_setEnabled(0);
		waReflectCover.hide();
		reflectCover.show();
		
		
		if (getData()!="blank")
			reflectCover.setXMLParam("image",getData());
		else
			reflectCover.setXMLParam("image",nocover.getXMLParam("image"));
			
		reflectCover.fx_setEnabled(1);
		reflectCover.fx_restart();
	}

}

reflectCover.fx_onFrame() {
	if(dblSmidge == 0.000001) 
		dblSmidge = 0;
	else
		dblSmidge = 0.000001;
}

reflectCover.fx_onGetPixelY(double r, double d, double x, double y) {
	return -y-dblSmidge;
}

waReflectCover.fx_onFrame() {
	if(dblSmidge2 == 0.000001) 
		dblSmidge2 = 0;
	else
		dblSmidge2 = 0.000001;
}

waReflectCover.fx_onGetPixelY(double r, double d, double x, double y) {
	return -y-dblSmidge2;
}

global int mousedown = FALSE;

resizer.onLeftButtonDown(int x, int y) {
	mousedown = TRUE;
}

resizer.onMouseMove(int x, int y) {
	if (!mousedown) return;
	
	int newsize = y - cdcover.getTop();
	
	if (newsize < 50) newsize = 50;
	if (newsize > 600) newsize = 600;
	
	cdcover_size_custom_pix_attrib.setData(integerToString(newsize));
}

resizer.onLeftButtonUp(int x, int y) {
	mousedown = FALSE;
}

