/*************************************************************

  KameleonDUI - config-customize.m
  by Leechbite

  scripts to control the customize tab of the config window.

*************************************************************/

#include <lib/std.mi>
#include "autorepeatbutton.m"
#include "attribs.m"
#include "utilities.m"

function setBkgroundToRGB();
function setPreviewToRGB(int r, int g, int b);
function refreshPreview();
function refreshGradient();
function refreshRGB();
function string RGBtoString(int R, int G, int B);

function redoBkgrounds();
function refreshBkgroundList();
function drawBkgrounds();
function string getBkEntryDetails(string objID, int tokennum);

function addBkGround(string imageID, string imageName, boolean tile);
function deleteBkground(string imageID);

Global string bkgroundList, bkgroundUSERList;
Global int numBkGround;
							
class layer bkgroundIcon;
class layer bkgroundGroupMousetrap;
global bkgroundIcon currImage;
Global bkgroundGroupMousetrap groupMouseTrap;
Global group scriptGroup;
Global slider sliderRed, sliderGreen, sliderBlue;
global guiObject gradRed, gradGreen, gradBlue;
Global guiObject previewRGB, previewImage, previewGroup, previewGradV, previewGradH;
Global string previewImageStr;

Global group bkgroundGroupParent, bkgroundGroup;
Global autoRepeatButton BkscrollLeft, BkscrollRight;
global guiobject bkgroundSlider;
global int onBgSliderMove, lastBgSliderX, lastlistpos;
Global button bkgroundAdd, bkgroundDelete;
Global string cursorImageID;
Global guiObject bkCursor;
Global int listPos;

Global container addQueryContainer, subConfirmContainer;
Global layout addQueryLayout, subConfirmLayout;
Global layer subPrev;
Global edit addPath;
Global button addButton, subYesButton;
Global checkbox addTile;

Global button colorSolid, colorGradV, colorGradH, colorColor1, colorColor2;
Global guiObject rgbColor1, rgbColor2;

Global button apply;
Global checkbox autoApply;

Global boolean localChange = FALSE, onStart;
Global string currentPreview;

System.onScriptLoaded() {
	initAttribs();
	AutoRepeat_Load();
	
	scriptGroup = getScriptGroup();
	previewRGB = scriptGroup.getObject("preview.rgb");
	previewGradV = scriptGroup.getObject("preview.gradient.vert");
	previewGradH = scriptGroup.getObject("preview.gradient.hort");
	previewImage = scriptGroup.getObject("preview.image");
	previewGroup = scriptGroup.getObject("preview.group");;

	colorSolid = scriptGroup.findObject("button.solid");
	colorGradV = scriptGroup.findObject("button.gradv");
	colorGradH = scriptGroup.findObject("button.gradh");
	colorColor1 = scriptGroup.findObject("button.color1");
	colorColor2 = scriptGroup.findObject("button.color2");
	rgbColor1 = scriptGroup.findObject("rgb.color1");
	rgbColor2 = scriptGroup.findObject("rgb.color2");
	
	sliderRed = findXUIObject(scriptGroup,"slider.red","slider.button");
	sliderGreen = findXUIObject(scriptGroup,"slider.green","slider.button");
	sliderBlue = findXUIObject(scriptGroup,"slider.blue","slider.button");
	
	gradRed = scriptGroup.findObject("gradient.red");
	gradGreen = scriptGroup.findObject("gradient.green");
	gradBlue = scriptGroup.findObject("gradient.blue");

	apply = scriptGroup.getObject("button.apply");
	autoApply = scriptGroup.getObject("autoapply");
	autoApply.setChecked(getPrivateInt("KameleonDUI","Config auto-apply",1));
		
	rgbColor1.setXMLParam("color",getPrivateString("KameleonDUI","color1",COLOR1DEF));
	rgbColor2.setXMLParam("color",getPrivateString("KameleonDUI","color2",COLOR2DEF));
	onStart = TRUE;
	config_custom_color1_attrib.onDataChanged();
	config_custom_color2_attrib.onDataChanged();
	refreshRGB();
	onStart = FALSE;
	
	currentPreview = getPrivateString("KameleonDUI","Config Current Preview","RGB");
	bkgroundList= "Carbon Fibre|IMAGE|bkground.checkers|TILE|SYSTEM~"+
							"Sport 1|IMAGE|bkground.industrial|TILE|SYSTEM~"+
							"Pine Wood|IMAGE|bkground.pinewood|TILE|SYSTEM~"+
							"Rose Wood|IMAGE|bkground.rosewood|TILE|SYSTEM~"+
							"Brushed Metal|IMAGE|bkground.brushedmetal|TILE|SYSTEM~"+
							"Pajama|IMAGE|bkground.bluestripe|TILE|SYSTEM~"+
							"Red Flame|GROUP|bkground.group.redflame||SYSTEM~"+
							"Blue Flame|GROUP|bkground.group.blueflame||SYSTEM~"+
							"Black Flame|GROUP|bkground.group.blackflame||SYSTEM~"+
							"Army Tropics|IMAGE|bkground.camouflage.army|TILE|SYSTEM~"+
							"Army Dessert|IMAGE|bkground.camouflage.army.dessert|TILE|SYSTEM~"+
							"Army Urban|IMAGE|bkground.camouflage.army.urban|TILE|SYSTEM~"+
							"Army Blue|IMAGE|bkground.camouflage.army.blue|TILE|SYSTEM~"+
							"Marble 1|IMAGE|bkground.marble.1|TILE|SYSTEM~"+
							"Marble 2|IMAGE|bkground.marble.2|TILE|SYSTEM~"+
							"Marble 3|IMAGE|bkground.marble.3|TILE|SYSTEM~"+
							"Diamond Plate Old|IMAGE|bkground.metal.diamondplate|TILE|SYSTEM~"+
							"Diamond Plate New|IMAGE|bkground.metal.diamondplate.2|TILE|SYSTEM~"+
							"Jollibee|IMAGE|bkground.bee|TILE|SYSTEM~"+
							"Denim|IMAGE|bkground.denim|TILE|SYSTEM~"+
							"Circuit Board|IMAGE|bkground.circuitboard|TILE|SYSTEM~"+
							"QH's Matrix Wave|IMAGE|bkground.qh.matrixwv|TILE|SYSTEM~"+
							"QH's Titanium|IMAGE|bkground.qh.titanium|TILE|SYSTEM~"+
							"QH's Carbon Fibre|IMAGE|bkground.qh.carbon|TILE|SYSTEM~"+
							"QH's Diamond Brushed Metal|IMAGE|bkground.qh.brushedmetal2|TILE|SYSTEM"+
							getPrivateString("KameleonDUI","MoreBkgrounds","");
	numBkGround = 0;
	bkgroundGroupParent = scriptGroup.getObject("config.customize.bkgrounds");
	bkgroundGroup = bkgroundGroupParent.getObject("config.customize.bkgrounds.list");
	BkscrollLeft = scriptGroup.findObject("button.scroll.left");
	BkscrollRight = scriptGroup.findObject("button.scroll.right");
	bkgroundSlider = scriptGroup.findObject("config.customize.bkgrounds.slider");
	bkgroundAdd = scriptGroup.findObject("button.add");
	bkgroundDelete = scriptGroup.findObject("button.sub");
	bkCursor = scriptGroup.findObject("cursor");
	bkCursor.hide();
	listPos = getPrivateInt("KameleonDUI","Config Bkround Pos",0);

	currentPreview = getPrivateString("KameleonDUI","Config current preview","RGB:0,0,0");
	previewImageStr = getPrivateString("KameleonDUI","Config preview image","");
	
	drawBkgrounds();
	refreshPreview();
	
}

System.onScriptUnloading() {
	AutoRepeat_unLoad();
	
}

redoBkgrounds() {
	string allbkground = bkgroundList + getPrivateString("KameleonDUI","user bkgrounds","");
	int counter = 1, numobj;
	guiObject currObj = NULL;
	
	numobj = bkgroundGroup.getNumObjects();
	
	do {
		currObj = bkgroundGroup.enumObject(counter);
		if (isObjectValid(currObj)) {
			currObj.hide();
			delete currObj;
			currObj = NULL;
		}
		counter++;
	} while (counter <= numobj);
	currObj = NULL;
	
	drawBkgrounds();
	refreshPreview();
}

windows_config_attrib.onDataChanged() {
	if (getData()=="0") {
		redoBkgrounds();
		
		localChange = TRUE;
		
		rgbColor1.setXMLParam("color",getPrivateString("KameleonDUI","color1",COLOR1DEF));
		rgbColor2.setXMLParam("color",getPrivateString("KameleonDUI","color2",COLOR2DEF));
		onStart = TRUE;
		config_custom_color1_attrib.onDataChanged();
		config_custom_color2_attrib.onDataChanged();
		refreshRGB();
		onStart = FALSE;
		
		autoApply.setChecked(getPrivateInt("KameleonDUI","Config auto-apply",1));
		
		currentPreview = getPrivateString("KameleonDUI","Config current preview","RGB:0,0,0");
		previewImageStr = getPrivateString("KameleonDUI","Config preview image","");
		refreshPreview();

		localChange = FALSE;

	}
	
}

autoApply.onToggle(int newstate) {
	setPrivateInt("KameleonDUI","Config auto-apply",autoApply.isChecked());
}

apply.onLeftClick() {
	if (currentPreview == "IMAGE") {
		bkground_image_attrib.setData(previewImageStr);
	} else if (currentPreview == "GROUP") {
		bkground_image_attrib.setData(previewImageStr);
	} else {
		setBkgroundToRGB();
	}
}

refreshPreview() {
	string strtemp = "", bkDataEntry1 = "", bkDataEntry2 = "";
	
	if (currentPreview == "RGB") {
		previewGroup.hide();    previewGroup.setXMLParam("groupid", "");
		previewImage.hide();

		if (config_custom_solid_attrib.getData()=="1") {
			if (config_custom_color1_attrib.getData()=="1") {
				previewRGB.setXMLParam("color",getPrivateString("KameleonDUI","color1",COLOR1DEF));
			} else {
				previewRGB.setXMLParam("color",getPrivateString("KameleonDUI","color2",COLOR2DEF));
			}
			previewRGB.show();
			previewGradV.hide(); previewGradH.hide();
		} else if (config_custom_gradv_attrib.getData()=="1") {
			previewGradV.show(); previewGradH.hide();
			previewGradV.setXMLParam("points", "0.0="+getPrivateString("KameleonDUI","color1",COLOR1DEF)+",255;1.0="+getPrivateString("KameleonDUI","color2",COLOR2DEF)+",255");
		} else {
			previewGradV.hide(); previewGradH.show();
			previewGradH.setXMLParam("points", "0.0="+getPrivateString("KameleonDUI","color1",COLOR1DEF)+",255;1.0="+getPrivateString("KameleonDUI","color2",COLOR2DEF)+",255");
		}
	} else if (currentPreview == "IMAGE") {

		strtemp = getToken(previewImageStr, ";" ,0);
		if (strtemp!="") bkDataEntry1 = strright(strtemp, strlen(strtemp)-strsearch(strtemp, ":")-1);
		
		previewImage.setXMLParam("image",bkDataEntry1);
		previewRGB.hide();
		previewImage.show();
		previewGroup.hide();
		
	} else if (currentPreview == "GROUP") {

  		strtemp = getToken(previewImageStr, ";" ,0);
  		if (strtemp!="") bkDataEntry1 = strright(strtemp, strlen(strtemp)-strsearch(strtemp, ":")-1);
		
		previewGroup.setXMLParam("groupid",bkDataEntry1);
		previewRGB.hide();
		previewImage.hide();
		previewGroup.show();
		
	}
	
	setPrivateString("KameleonDUI","Config current preview",currentPreview);
	setPrivateString("KameleonDUI","Config preview image",previewImageStr);
}

string RGBtoString(int R, int G, int B) {
	string ret = integerToString(R)+",";
	ret += integerToString(G)+",";
	ret += integerToString(B);
	
	return ret;
}

refreshGradient() {
	string point1 = RGBtoString(0,sliderGreen.getPosition(),sliderBlue.getPosition());
	string point2 = RGBtoString(255,sliderGreen.getPosition(),sliderBlue.getPosition());
	
	gradRed.setXMLParam("points","0.0="+point1+",255;1.0="+point2+",255");
	
	point1 = RGBtoString(sliderRed.getPosition(),0,sliderBlue.getPosition());
	point2 = RGBtoString(sliderRed.getPosition(),255,sliderBlue.getPosition());
	
	gradGreen.setXMLParam("points","0.0="+point1+",255;1.0="+point2+",255");
	
	point1 = RGBtoString(sliderRed.getPosition(),sliderGreen.getPosition(),0);
	point2 = RGBtoString(sliderRed.getPosition(),sliderGreen.getPosition(),255);
	
	gradBlue.setXMLParam("points","0.0="+point1+",255;1.0="+point2+",255");
}

refreshRGB() {
	string colstr = RGBtoString(sliderRed.getPosition(),sliderGreen.getPosition(),sliderBlue.getPosition());
	if (config_custom_color1_attrib.getData()=="1") {
		setPrivateString("KameleonDUI","color1",colstr);
		rgbColor1.setXMLParam("color",colstr);
	} else {
		setPrivateString("KameleonDUI","color2",colstr);
		rgbColor2.setXMLParam("color",colstr);
	}
}

sliderRed.onSetPosition(int newpos) {
	refreshGradient();
	
	if (localChange) return;
	currentPreview = "RGB";
	refreshRGB();
	refreshPreview();
	
	if (autoApply.isChecked()) setBkgroundToRGB();
}

sliderGreen.onSetPosition(int newpos) {
	refreshGradient();
	
	if (localChange) return;
	currentPreview = "RGB";
	refreshRGB();
	refreshPreview();
	
	if (autoApply.isChecked()) setBkgroundToRGB();
}

sliderBlue.onSetPosition(int newpos) {
	refreshGradient();
	
	if (localChange) return;
	currentPreview = "RGB";
	refreshRGB();
	refreshPreview();
	
	if (autoApply.isChecked()) setBkgroundToRGB();
}

setBkgroundToRGB() {
	
	if (config_custom_solid_attrib.getData()=="1") {
		if (config_custom_color1_attrib.getData()=="1")
			bkground_image_attrib.setData("RGB:"+getPrivateString("KameleonDUI","color1",COLOR1DEF));
		else
			bkground_image_attrib.setData("RGB:"+getPrivateString("KameleonDUI","color2",COLOR2DEF));
	} else if (config_custom_gradv_attrib.getData()=="1") {
		bkground_image_attrib.setData("GRADV:"+getPrivateString("KameleonDUI","color1",COLOR1DEF)+";"+getPrivateString("KameleonDUI","color2",COLOR2DEF));
	} else {
		bkground_image_attrib.setData("GRADH:"+getPrivateString("KameleonDUI","color1",COLOR1DEF)+";"+getPrivateString("KameleonDUI","color2",COLOR2DEF));
	}
}

setPreviewToRGB(int r, int g, int b) {
	previewRGB.setXMLParam("color",integerToString(r)+","+integerToString(g)+","+integerToString(b));
}

config_custom_solid_attrib.onDataChanged() {
	if (getData()!="1") return;
	
	currentPreview = "RGB";
	refreshPreview();
	
	if (autoApply.isChecked()) setBkgroundToRGB();
}

config_custom_gradv_attrib.onDataChanged() {
	if (getData()!="1") return;
	
	currentPreview = "RGB";
	refreshPreview();
	
	if (autoApply.isChecked()) setBkgroundToRGB();
}

config_custom_gradh_attrib.onDataChanged() {
	if (getData()!="1") return;
	
	currentPreview = "RGB";
	refreshPreview();
	
	if (autoApply.isChecked()) setBkgroundToRGB();
}

config_custom_color1_attrib.onDataChanged() {
	if (getData()!="1") return;
	
	string colstr = getPrivateString("KameleonDUI","color1",COLOR1DEF);
	
	localChange = TRUE;
	sliderRed.setPosition(stringToInteger(getToken(colstr,",",0)));
	sliderGreen.setPosition(stringToInteger(getToken(colstr,",",1)));
	sliderBlue.setPosition(stringToInteger(getToken(colstr,",",2)));
	localChange = FALSE;
	
	if (currentPreview == "RGB" && config_custom_solid_attrib.getData()=="1") {
		refreshPreview();
		if (autoApply.isChecked() && !onStart) setBkgroundToRGB();
	}
}

config_custom_color2_attrib.onDataChanged() {
	if (getData()!="1") return;
	
	string colstr = getPrivateString("KameleonDUI","color2",COLOR2DEF);
	
	localChange = TRUE;
	sliderRed.setPosition(stringToInteger(getToken(colstr,",",0)));
	sliderGreen.setPosition(stringToInteger(getToken(colstr,",",1)));
	sliderBlue.setPosition(stringToInteger(getToken(colstr,",",2)));
	localChange = FALSE;
	
	if (currentPreview == "RGB" && config_custom_solid_attrib.getData()=="1") {
		refreshPreview();
		if (autoApply.isChecked() && !onStart) setBkgroundToRGB();
	}
}

drawBkgrounds() {
	string currEntry = "", name="", objID="", type="", dispmode="";
	string allbkground = bkgroundList + getPrivateString("KameleonDUI","user bkgrounds","");
	
	string strtemp, previewImageID;
	
	numBkGround = 0;
	
	group bkGroup;
	
	do {
		currEntry = getToken(allbkground,"~",numBkGround);
		if (currEntry != "") {
			
			name = getToken(currEntry,"|",0);
			type = strupper(getToken(currEntry,"|",1));
			objID = getToken(currEntry,"|",2);
			dispmode = strupper(getToken(currEntry,"|",3));
			if (type=="GROUP") {
				
				strtemp = getToken(previewImageStr, ";" ,0);
				if (strtemp!="") previewImageID = strupper(strright(strtemp, strlen(strtemp)-strsearch(strtemp, ":")-1));
	
				if (previewImageID == strupper(objID)) {
					bkCursor.setXMLParam("x", integerToString(numBkGround*45));
					bkCursor.show();
					
					bkgroundDelete.setAlpha(128);
					bkgroundDelete.setXMLParam("ghost","1");

					cursorImageID = objID;
				}
				
				bkGroup = newGroup(objID);
				bkGroup.setXMLParam("image", objID);
				bkGroup.setXMLParam("x", integerToString(numBkGround*45+2));
				bkGroup.setXMLParam("y", "2");
				bkGroup.setXMLParam("w", "36");
				bkGroup.setXMLParam("h", "36");
				bkGroup.setXMLParam("relatw", "0");
				bkGroup.setXMLParam("relath", "0");
				bkGroup.init(bkgroundGroup);
				
				groupMouseTrap = bkGroup.getObject("mousetrap");
				if (groupMouseTrap) {
					groupMouseTrap.setXMLParam("move", "0");
					groupMouseTrap.setXMLParam("tooltip", name);
				}
				
			} else {
				
				strtemp = getToken(previewImageStr, ";" ,0);
				if (strtemp!="") previewImageID = strupper(strright(strtemp, strlen(strtemp)-strsearch(strtemp, ":")-1));
	
				if (previewImageID == strupper(objID)) {
					bkCursor.setXMLParam("x", integerToString(numBkGround*45));
					bkCursor.show();
					
					if (getToken(currEntry,"|",4)=="SYSTEM") { 
						bkgroundDelete.setAlpha(128);
						bkgroundDelete.setXMLParam("ghost","1");
					} else { 
						bkgroundDelete.setAlpha(255);
						bkgroundDelete.setXMLParam("ghost","0");
					}
					cursorImageID = objID;
				}
				
				currImage = new Layer;
				currImage.setXMLParam("image", objID);
				currImage.setXMLParam("x", integerToString(numBkGround*45+2));
				currImage.setXMLParam("y", "2");
				currImage.setXMLParam("w", "36");
				currImage.setXMLParam("h", "36");
				currImage.setXMLParam("move", "0");
				currImage.setXMLParam("tooltip", name);
				currImage.init(bkgroundGroup);
				bkgroundGroup.setXMLParam("w", integerToString(numBkGround*45+40));
				

			}
			numBkGround++;
		}
		

	} while (currEntry != "");
	
	refreshBkgroundList();
}

addBkGround(string imageID, string imageName, boolean tile) {
	string temp = "";
	int count = 0;
	if (imageName=="") {
		do {
			temp = getToken(imageID,"\\ ",count);
			if (temp!="") imageName = temp;
			count++;
		} while (temp!="");
	}

	string bkgroundUser = getPrivateString("KameleonDUI","user bkgrounds","");
	
	string strtile = "STRETCH";
	if (tile) strtile = "TILE";
	bkgroundUser = bkgroundUser + "~" + imageName+ "|IMAGE|" + imageID + "|" + strtile;
	
	setPrivateString("KameleonDUI","user bkgrounds",bkgroundUser);
	
	currImage = new Layer;
	currImage.setXMLParam("image", imageID);
	currImage.setXMLParam("x", integerToString(numBkGround*45+2));
	currImage.setXMLParam("y", "2");
	currImage.setXMLParam("w", "36");
	currImage.setXMLParam("h", "36");
	currImage.setXMLParam("move", "0");
	currImage.setXMLParam("tooltip", imageName);
	currImage.init(bkgroundGroup);
	bkgroundGroup.setXMLParam("w", integerToString(numBkGround*45+40));
	numBkGround++;
	
	listPos = bkgroundGroupParent.getWidth() - bkgroundGroup.getWidth();
	refreshBkgroundList();
}

deleteBkGround(string imageID) {
	string currEntry, newbkgroundUser = "", objID;
	string bkgroundUser = getPrivateString("KameleonDUI","user bkgrounds","");
	int counter = 1;
	
	imageID = strupper(imageID);
	if (strsearch(strupper(bkground_image_attrib.getData()),imageID) > 0) {
		setBkgroundToRGB();
		currentPreview = "RGB";
		refreshPreview(); 
	}
	
	do {
		currEntry = getToken(bkgroundUser,"~",counter);
		if (currEntry != "") {

			objID = strupper(getToken(currEntry,"|",2));

			if (objID != imageID) {
				newbkgroundUser = newbkgroundUser+"~"+currEntry;
			}
		}
		counter++;
	} while (currEntry != "");
	
	counter = 0; //bkgroundGroup.getNumObjects() - 1;
	int offsetX = 0;
	int numobj = bkgroundGroup.getNumObjects();
	guiObject currObj = NULL;
	for (counter = 0; counter <=  numobj; counter++) {
		
		currObj = bkgroundGroup.enumObject(counter);
		if (isObjectValid(currObj)) {
			if (strupper(currObj.getClassName())=="LAYER") {
				string imgID = strupper(currObj.getXMLParam("image"));
				if (imgID == imageID) {
					delete currObj;
					currObj = NULL;
					
					offsetX = offsetX + 45;
					
					numBkGround--;
					bkgroundGroup.setXMLParam("w", integerToString((numBkGround-1)*45+40));
					
					counter--;

				} else {
					currObj.setXMLParam("x", integerToString(stringToInteger(currObj.getXMLParam("x")) - offsetX));
				}
			}
		}

	}
	
	setPrivateString("KameleonDUI","user bkgrounds",newbkgroundUser);
	
	refreshBkgroundList();
	
}

refreshBkgroundList() {
	int bgwidth = bkgroundGroup.getWidth();
	int bgwidthparent = bkgroundGroupParent.getWidth();
	
	if ((numBkGround*45+36) < bgwidthparent) listpos = 0;
	
	if ((bgwidth+listPos) < bgwidthparent) listPos = bgwidthparent - bgwidth;
	if (listPos > 0) listPos = 0;
	
	bkgroundGroup.setXMLParam("x",integerToString(listPos));
	
	int sliderwid = bgwidthparent*bgwidthparent/bgwidth;
	if (sliderwid < 15) sliderwid = 15;
	if (sliderwid > bgwidthparent) sliderwid = bgwidthparent;
	
	int sliderpos = listpos*(bgwidthparent-sliderwid)/(bgwidthparent - bgwidth);
	
	bkgroundSlider.setXMLParam("x",integerToString(sliderpos));
	bkgroundSlider.setXMLParam("w",integerToString(sliderwid));
	
	setPrivateInt("KameleonDUI","Config Bkround Pos",listPos);
}

bkgroundSlider.onLeftButtonDown(int x, int y) {
	onBgSliderMove = 1;
	lastBgSliderX = x;
	lastlistpos = listpos;
}

bkgroundSlider.onLeftButtonUp(int x, int y) {
	onBgSliderMove = 0;
	
}

bkgroundSlider.onMouseMove(int x, int y) {
	if (!onBgSliderMove) return;
	
	int bgwidth = bkgroundGroup.getWidth();
	int bgwidthparent = bkgroundGroupParent.getWidth();
	
	listpos = lastlistpos+(x-lastBgSliderX)*(bgwidthparent - bgwidth)/(bgwidthparent-getWidth());
	refreshBkgroundList();
}

bkgroundIcon.onLeftButtonDown(int x, int y) {
	currentPreview = "IMAGE";
	previewImageStr = "IMAGE:"+getXMLParam("image")+";"+integerToString(getBkEntryDetails(getXMLParam("image"), 3)=="TILE");
	cursorImageID = getXMLParam("image");
	
	refreshPreview();
	if (autoApply.isChecked()) apply.onleftClick();
	
	bkCursor.setXMLParam("x", integerToString(getguix()-2));
	bkCursor.show();
	if (getBkEntryDetails(getXMLParam("image"), 4)=="SYSTEM") { 
		bkgroundDelete.setAlpha(128);
		bkgroundDelete.setXMLParam("ghost","1");
	} else { 
		bkgroundDelete.setAlpha(255);
		bkgroundDelete.setXMLParam("ghost","0");
	}
	
}

bkgroundIcon.onLeftButtonDblClk(int x, int y) {
	currentPreview = "IMAGE";
	previewImageStr = "IMAGE:"+getXMLParam("image")+";"+integerToString(getBkEntryDetails(getXMLParam("image"), 3)=="TILE");
	cursorImageID = getXMLParam("image");
	
	refreshPreview();
	apply.onleftClick();
	
	bkCursor.setXMLParam("x", integerToString(getguix()-2));
	bkCursor.show();
	if (getBkEntryDetails(getXMLParam("image"), 4)=="SYSTEM") { 
		bkgroundDelete.setAlpha(128);
		bkgroundDelete.setXMLParam("ghost","1");
	} else { 
		bkgroundDelete.setAlpha(255);
		bkgroundDelete.setXMLParam("ghost","0");
	}
}

bkgroundGroupMousetrap.onLeftButtonDown(int x, int y) {
	currentPreview = "GROUP";
	group parentGroup = getParent();
	string groupID = parentGroup.getID();
	previewImageStr = "GROUP:"+groupID;
	
	refreshPreview();
	if (autoApply.isChecked()) apply.onleftClick();

	bkCursor.setXMLParam("x", integerToString(parentGroup.getguix()-2));
	bkCursor.show();

	bkgroundDelete.setAlpha(128);
	bkgroundDelete.setXMLParam("ghost","1");
}

bkgroundGroupMousetrap.onLeftButtonDblClk(int x, int y) {
	currentPreview = "GROUP";
	group parentGroup = getParent();
	string groupID = parentGroup.getID();
	previewImageStr = "GROUP:"+groupID;
	
	refreshPreview();
	apply.onleftClick();

	bkCursor.setXMLParam("x", integerToString(parentGroup.getguix()-2));
	bkCursor.show();

	bkgroundDelete.setAlpha(128);
	bkgroundDelete.setXMLParam("ghost","1");
}

BkscrollRight.onLeftClick() {
	if (AutoRepeat_ClickType == 1) return;
	
	listPos = listPos - 10;
	
	refreshBkgroundList();
}

BkscrollLeft.onLeftClick() {
	if (AutoRepeat_ClickType == 1) return;
	
	listPos = listPos + 10;
	if (listPos > 0) listPos = 0;
	
	refreshBkgroundList();
}

bkgroundGroupParent.onResize(int x, int y, int w, int h) {
	refreshBkgroundList();
}


string getBkEntryDetails(string objID, int tokennum) {
	
	int counter = 0;
	string currobjID="", currEntry="";
	string allbkground = bkgroundList + getPrivateString("KameleonDUI","user bkgrounds","");
	
	objID = strlower(objID);
	
	do {
		currEntry = getToken(allbkground,"~",counter);
		if (currEntry != "") {
			currobjID = strlower(getToken(currEntry,"|",2));
			if (objID==currobjID) {
				return getToken(currEntry,"|",tokennum);

			}
		}
		
		counter++;
	} while (currEntry != "");
	return "";
}


bkgroundAdd.onLeftClick() {

	if (isObjectValid(addQueryContainer)) { // if open, dont reopen
		layout addLayout = addQueryContainer.enumLayout(0);
		addLayout.setFocus();
		addLayout.center();
		return;
	}
	addQueryContainer = newDynamicContainer("config.addbkground");
	
	if (addQueryContainer) {
		addQueryContainer.show();
		addQueryLayout = addQueryContainer.getLayout("normal");
		addQueryLayout.center();
		addPath = addQueryLayout.findObject("filename");
		addButton = addQueryLayout.findObject("add");
		addTile = addQueryLayout.findObject("tile");
		addTile.setChecked(1);
	}
}

addButton.onLeftClick() {
	map filecheck;
	filecheck = new map;
	filecheck.loadMap(addPath.getText());
	
	if (filecheck.getWidth() >0) {
		addBkGround(addPath.getText(), "" , addTile.isChecked());
		addQueryContainer.close();
		addQueryContainer = NULL;
	} else {
		text label = addQueryLayout.findObject("label");
		label.setText("ERROR: Cannot load image. Re-enter image path:");
	}
	
	delete filecheck;
}

addPath.onEnter() {
	addButton.onLeftClick();
}

bkgroundDelete.onLeftClick() {
	if (isObjectValid(subConfirmContainer)) { // if open, dont reopen
		layout subLayout = subConfirmContainer.enumLayout(0);
		subLayout.setFocus();
		subLayout.center();
		return;
	}
	
	
	subConfirmContainer	= newDynamicContainer("config.deletebkground");
	if (subConfirmContainer) {
		subConfirmContainer.show();
		subConfirmLayout = subConfirmContainer.getLayout("normal");
		subConfirmLayout.center();
		subYesButton = subConfirmLayout.findObject("yes");
		subPrev = subConfirmLayout.findObject("preview");
		subPrev.setXMLParam("image",cursorImageID);
	}
}


subYesButton.onLeftClick() {
	deleteBkground(subPrev.getXMLParam("image"));
	subConfirmContainer.close();
	subConfirmContainer = NULL;
	
	bkCursor.hide();
	bkgroundDelete.setAlpha(128);
	bkgroundDelete.setXMLParam("ghost","1");

}

// ****** used home page texture install from ibrowser. ****

inetbrowser_openpage_attrib.onDataChanged() {
	if (getData()=="") return;
	if (strleft(getData(),5) != "ADDBG") return;
	
	if (windows_config_attrib.getData()=="1") {
		if (getPrivateInt("KameleonDUI","ADDBG",0)!=1) {
			listPos = bkgroundGroupParent.getWidth() - (bkgroundGroup.getWidth()*2);
			redoBkgrounds();
			return;
		}
	}
	setPrivateInt("KameleonDUI","ADDBG",0);
	
	string raw = getToken(getData(),";",1);
	string fname = getToken(raw,"|",0);
	string tname = getToken(raw,"|",1);
	string tile = getToken(raw,"|",2);
	string ct = getToken(raw,"|",3);
	
	string bkgroundUser = getPrivateString("KameleonDUI","user bkgrounds","");
	string currEntry, currobjID;
	int counter = 1, found = 0;
	string strtile = "STRETCH";
	if (tile=="1") strtile = "TILE";
	
	string fnamenopath = removePath(fname);
	int fnamelen = strlen(fname);
	
	// *** check if texture already in list.
	do {
		currEntry = getToken(bkgroundUser,"~",counter);
		if (currEntry != "") {
			currobjID = strlower(getToken(currEntry,"|",2));
			if (fnamenopath==removePath(currobjID) && fnamelen== strlen(currobjID)) { // ** because maki's string comp is broken...
				found = 1;
			}
		}
		
		counter++;
	} while (currEntry != "");
	
	currentPreview = "IMAGE";
	previewImageStr = "IMAGE:"+fname+";"+tile;
	cursorImageID = fname;
	refreshPreview();
	
	if (!found) {
		addBkGround(fname, tname, tile=="1");
		listPos = bkgroundGroupParent.getWidth() - (bkgroundGroup.getWidth()*2);
		refreshBkgroundList();
	}
	
	apply.onleftClick();
	
	// shows/opens the customize tab on config panel
	if (!scriptGroup.isVisible()) {
		layout parent = scriptGroup.getParentLayout();
		if (parent) {
			if (!parent.isVisible()) {
				setPrivateInt(getSkinName(),"Config Curr Tab",0);
				parent.show();
			} else {
				tabsheet configtab = parent.findObject("config.tabs");
				if (configtab) { configtab.setCurPage(0); }
			}
		}
	}
}