/*************************************************************

  KameleonDUI - config-main.m
  by Leechbite

  scripts to control the rest of the config window.

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

global group scriptGroup;
global button browser_button_homepagedef, cdcover_button_skipalbum;
global edit browser_edit_homepagedef, cdcover_edit_skipalbum;
global tabsheet configtab;
global button detachButton;

global boolean localChange = 0;


System.onScriptLoaded() {
	initAttribs();
	
	scriptGroup = getScriptGroup();
	browser_button_homepagedef = scriptGroup.findObject("config.button.homepage");
	browser_edit_homepagedef = scriptGroup.findObject("config.edit.homepage");
	cdcover_edit_skipalbum = scriptGroup.findObject("cdcover.skipalbums");
	cdcover_button_skipalbum = scriptGroup.findObject("config.button.skipalbums");
	configtab = scriptGroup.findObject("config.tabs");
	configtab.setCurPage(getPrivateInt(getSkinName(),"Config Curr Tab",0));
	
	// the following is used only by dui version of configp
	group parentGroup = scriptGroup.getParent();
	detachButton = parentGroup.findObject("dui.detach");
	
	inetbrowser_homepage_attrib.onDataChanged();
	cdcover_edit_skipalbum.setText(getPrivateString("KameleonDUI","CDCover SkipAlbumNames","unknown,unknown album,album,no title"));
}

System.onScriptUnloading() {
	setPrivateInt(getSkinName(),"Config Curr Tab",configtab.getCurPage());
	
	guiObject ctlist = scriptGroup.findObject("config.colorthemes.list");
	delete ctlist; // if not done, winamp crashes on skin-reload if configp is attached.
	
	return;
}

windows_config_attrib.onDataChanged() {
	if (getData()=="1") {
		setPrivateInt(getSkinName(),"Config Curr Tab",configtab.getCurPage());
	} else {
		configtab.setCurPage(getPrivateInt(getSkinName(),"Config Curr Tab",0));
		cdcover_edit_skipalbum.setText(getPrivateString("KameleonDUI","CDCover SkipAlbumNames","unknown,unknown album,album,no title"));
	}
}

scriptGroup.onSetVisible(int on) {
	if (on) {
		configtab.setCurPage(getPrivateInt(getSkinName(),"Config Curr Tab",0));
		
	}
}

// onLeftButtonDown is used to make sure it initiates before onLeftClick does
// on dui-local script.
detachButton.onLeftButtonDown(int x, int y) {
	setPrivateInt(getSkinName(),"Config Curr Tab",configtab.getCurPage());
}

browser_button_homepagedef.onLeftClick() {

	inetbrowser_homepage_attrib.setData(INET_HOMEPAGE);
}

browser_edit_homepagedef.onEnter() {
	if (localChange) return;
	
	localChange = 1;
	inetbrowser_homepage_attrib.setData(getText());
	localChange = 0;
}

inetbrowser_homepage_attrib.onDataChanged() {
	if (localChange) return;
	
	localChange = 1;
	browser_edit_homepagedef.setText(getData());
	localChange = 0;
}

cdcover_edit_skipalbum.onEditUpdate() {
	setPrivateString("KameleonDUI","CDCover SkipAlbumNames",getText());
}

cdcover_button_skipalbum.onLeftClick() {
	cdcover_edit_skipalbum.setText("unknown,unknown album,album,no title");
	setPrivateString("KameleonDUI","CDCover SkipAlbumNames","unknown,unknown album,album,no title");
}