/*************************************************************

  KameleonDUI - eq-presets.m
  by Leechbite

  - script for the EQ preset buttons, including the
    programmable USER button.

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"
#include "eq-utilities.m"

Global group frameGroup;
Global layout eqLayout;

Global button eqFULL, eqROCK, eqPOP, eqSOFT, eqDANCE, eqUSER;
Global int eqUser0,eqUser1,eqUser2,eqUser3,eqUser4,eqUser5,eqUser6,eqUser7,eqUser8,eqUser9,eqUserPreamp;

Global timer eqUsertimer;
Global boolean eqUserDown;

System.onScriptLoaded() {
  initAttribs();
  
  frameGroup = getScriptGroup();
  
  eqFULL = frameGroup.findObject("eq.preset.full");
  eqROCK = frameGroup.findObject("eq.preset.rock");
  eqPOP = frameGroup.findObject("eq.preset.pop");
  eqDANCE = frameGroup.findObject("eq.preset.dance");
  eqSOFT = frameGroup.findObject("eq.preset.soft");
  eqUSER = frameGroup.findObject("eq.preset.user");

  eqUser0 = getPrivateInt(getSkinName(), "User EQ 0", 1);
  eqUser1 = getPrivateInt(getSkinName(), "User EQ 1", 1);
  eqUser2 = getPrivateInt(getSkinName(), "User EQ 2", 1);
  eqUser3 = getPrivateInt(getSkinName(), "User EQ 3", 1);
  eqUser4 = getPrivateInt(getSkinName(), "User EQ 4", 1);
  eqUser5 = getPrivateInt(getSkinName(), "User EQ 5", 1);
  eqUser6 = getPrivateInt(getSkinName(), "User EQ 6", 1);
  eqUser7 = getPrivateInt(getSkinName(), "User EQ 7", 1);
  eqUser8 = getPrivateInt(getSkinName(), "User EQ 8", 1);
  eqUser9 = getPrivateInt(getSkinName(), "User EQ 9", 1);
  eqUserPreamp = getPrivateInt(getSkinName(), "User EQ Preamp", 1);
  
  eqUserTimer = new Timer;
  eqUserTimer.setDelay(750);

}

System.onScriptUnLoading() {
  delete eqUserTimer;
}

setEQPreset(int preamp, int eq0, int eq1, int eq2, int eq3, 
	int eq4, int eq5, int eq6, int eq7, int eq8, int eq9) {

  setEQPreamp(preamp);
  setEQBand(0, eq0);
  setEQBand(1, eq1);
  setEQBand(2, eq2);
  setEQBand(3, eq3);
  setEQBand(4, eq4);
  setEQBand(5, eq5);
  setEQBand(6, eq6);
  setEQBand(7, eq7);
  setEQBand(8, eq8);
  setEQBand(9, eq9);
}

eqFULL.onLeftClick() {
  setEQPreset(EQ_Full);
  setTempText("FULL|Equalizer");
}

eqROCK.onLeftClick() {
  setEQPreset(EQ_Rock);
  setTempText("ROCK|Equalizer");
}

eqPOP.onLeftClick() {
  setEQPreset(EQ_Pop);
  setTempText("POP|Equalizer");
}

eqSOFT.onLeftClick() {
  setEQPreset(EQ_Soft);
  setTempText("SOFT|Equalizer");
}

eqDANCE.onLeftClick() {
  setEQPreset(EQ_Dance);
  setTempText("DANCE|Equalizer");
}

eqUSER.onLeftButtonDown(int x, int y) {
  eqUserTimer.start();
  eqUserDown = TRUE;
}

eqUSER.onLeftButtonUp(int x, int y) {
	if (eqUserTimer.isRunning()) {
		eqUserTimer.stop();
		setEQPresetUSER();
		setTempText("USER|Equalizer");
	}
		eqUserDown = FALSE;
}

eqUserTimer.onTimer() {
	stop();
	eqUserDown = FALSE;
	
	setUSEREQ();
	
	setTempText("USER EQ SET|Equalizer");
}