
/*************************************************************

  KameleonDUI - fullscreen-button.m
  by Leechbite

  script for the fullscreen button. script is specific for KameleonDUI
  and may not work on other skins.
  
  param = "fullbuttonID,restorebuttonID"
  
  buttonID - button ID. im using right now XUI objects so should be the XUI id.
  
*************************************************************/

#include <lib/std.mi>
#include "utilities.m"

Global group scriptGroup;
Global layout scriptLayout;
Global group resizeGroup, moveGroup;
Global button fsbutton, restorebutton;
Global group fsXUIGroup, restoreXUIGroup;
Global boolean localResize = FALSE, onLoading = TRUE;
Global text titleText;
Global string layoutName;
Global int noSaveXYWH = FALSE;

Global timer delayRestoreFS;

System.onScriptLoaded() {
	onLoading = TRUE;
	
	scriptGroup = getScriptGroup();
	scriptLayout = scriptGroup.getParentLayout();
	
	string param = getParam();
	
	fsXUIGroup = scriptGroup.findObject(getToken(param,",",0));
	fsbutton = fsXUIGroup.getObject("xuibutton");
	
	restoreXUIGroup = scriptGroup.findObject(getToken(param,",",1));
	restorebutton = restoreXUIGroup.getObject("xuibutton");
	
	resizeGroup = scriptLayout.findObject("wasabi.frame.resize");
	moveGroup = scriptLayout.findObject("wasabi.frame.move");

	delayRestoreFS = new timer;
	delayRestoreFS.setDelay(100);
	
	titleText = scriptLayout.findObject("frame.title.dummy");
	if (strleft(titleText.getText(),1)!=":") titleText.onTextChanged(titleText.getText());
}

titleText.onTextChanged(string nt) {
	if (strleft(nt,1)==":") return;
	
	layoutName = nt;
	
	if (getPrivateInt(getSkinName(), layoutName+"_onFullScreen", 0) == 1) {
		noSaveXYWH = TRUE;
		delayRestoreFS.start();
	}
}

System.onScriptUnloading() {
	delete delayRestoreFS;
}

fsButton.onLeftClick() {
	int maxW = stringToInteger(scriptLayout.getXMLParam("maximum_w"));
	int maxH = stringToInteger(scriptLayout.getXMLParam("maximum_h"));
	
	if (maxW <= 0) maxW = 30000;
	if (maxH <= 0) maxH = 30000;
	
	if (maxW < getViewPortWidth()) return;
	if (maxH < getViewPortHeight()) return;
	
	if (!noSaveXYWH) {
		setPrivateInt(getSkinName(), layoutName+"_X", scriptLayout.getLeft());
		setPrivateInt(getSkinName(), layoutName+"_Y", scriptLayout.getTop());
		setPrivateInt(getSkinName(), layoutName+"_W", scriptLayout.getWidth());
		setPrivateInt(getSkinName(), layoutName+"_H", scriptLayout.getHeight());
	}
	noSaveXYWH = FALSE;
	
	setPrivateInt(getSkinName(), layoutName+"_onFullScreen", 1);
	
	localResize = TRUE;
	scriptLayout.resize(getViewPortLeft(), getViewPortTop(), getViewPortWidth(), getViewPortHeight());
	localResize = FALSE;
	
	resizeGroup.hide();
	moveGroup.hide();
	restoreXUIGroup.show();
	fsXUIGroup.hide();
}

restorebutton.onLeftClick() {
	int maxW = stringToInteger(scriptLayout.getXMLParam("maximum_w"));
	int maxH = stringToInteger(scriptLayout.getXMLParam("maximum_h"));
	int minW = stringToInteger(scriptLayout.getXMLParam("minimum_w"));
	int minH = stringToInteger(scriptLayout.getXMLParam("minimum_h"));
	
	if (maxW <= 0) maxW = 30000;
	if (maxH <= 0) maxH = 30000;

	int lw = getPrivateInt(getSkinName(), layoutName+"_W", 100);
	int lh = getPrivateInt(getSkinName(), layoutName+"_H", 100);
	
	if (lw > maxW) lw = maxW;
	if (lw < minW) lw = minW;
	if (lh > maxH) lh = maxH;
	if (lh < minH) lh = minH;

	localResize = TRUE;
	scriptLayout.resize(
		getPrivateInt(getSkinName(), layoutName+"_X", 50),
		getPrivateInt(getSkinName(), layoutName+"_Y", 50),
		lw,lh);
	localResize = FALSE;
	
	resizeGroup.show();
	moveGroup.show();
	fsXUIGroup.show();
	restoreXUIGroup.hide();
	
	setPrivateInt(getSkinName(), layoutName+"_onFullScreen", 0);
}

scriptLayout.onResize(int x, int y, int w, int h) {
	if (localResize) return;
	if (getPrivateInt(getSkinName(), layoutName+"_onFullScreen", 0)==0) return;

	resizeGroup.show();
	moveGroup.show();
	fsXUIGroup.show();
	restoreXUIGroup.hide();
}

scriptLayout.onEndMove() {
	scriptLayout.onResize(scriptLayout.getLeft(), scriptLayout.getTop(), scriptLayout.getWidth(), scriptLayout.getHeight());
}

delayRestoreFS.onTimer() {
	stop();
	
	fsButton.onLeftClick();
}


