/*************************************************************

  KameleonDUI - hideshow.m
  by Leechbite

  all-purpose script for hiding and showing guiObjects depending
  on width/height of parent group.
  
  takes 3 parameters: (eq. param="objID,hideW,hideH,maxW,maxH";
  objID = id of object to show and hide.
  hideW = width of parent group to hide/show object.
  hideH = height of parent group to hide/show object.
  maxW = max width of parent group to max object. (opt)
  maxH = max height of parent group to max object (opt)
  
*************************************************************/

#include <lib/std.mi>

Global group parentGroup;
Global guiObject obj;
Global int hideW, hideH;
Global int maxW, maxH;

System.onScriptLoaded() {
	parentGroup = getScriptGroup();
	string param = getParam();

	obj = parentGroup.findObject(getToken(param,",",0));
	hideW = stringToInteger(getToken(param,",",1));
	hideH = stringToInteger(getToken(param,",",2));
	maxW = stringToInteger(getToken(param,",",3));
	maxH = stringToInteger(getToken(param,",",4));
	if (maxW <= hideW) maxW = 16000; // if not given or bad value assign biggest possible value
	if (maxH <= hideH) maxH = 16000; // ..ditto..
	
	parentGroup.onResize(parentGroup.getLeft(),parentGroup.getTop(),
						parentGroup.getWidth(),parentGroup.getHeight());
						
}

System.onScriptUnloading() {
	return;
}

parentGroup.onResize(int x, int y, int w, int h) {
	if ((w <= hideW) || (h <= hideH) || (w >= maxW) || (h >= maxH)) {
		obj.hide();
	} else {
		obj.show();
	}
}