/*************************************************************

  ibrowser.m
  by Leechbite

  script for Internet Browser window

*************************************************************/

#include <lib/std.mi>
#include <lib/application.mi>
#include "attribs.m"
#include "utilities.m"

function moreArtistInfo();
function installTexture(string fname, string tname, string tile, string ct);
function installExtensions(string extname, string fnames);
function updateHomePage();

Global group scriptGroup;
Global browser ibrowser;
Global int masterScript;

Global edit urlbox;
Global button buttonBack, buttonFwd, buttonGo, buttonStop, buttonRefresh, buttonHome;
Global button buttonLyrics, buttonChords, buttonArtistSite;

Global string homeURL;

Global boolean localChange = false, onLoad;

global string lastDownloadPath, extPath, textureName, textureTile, colorTheme, newURL;
global int onDownload, onDownloadExt, numExtFiles, onDataChg;

global string last_autotitle, newBG;

global timer delayURL, delayInstallBG;

System.onScriptLoaded() {
	initAttribs();

	scriptGroup = getScriptGroup();
	
	extPath = getParam()+"\KamDUI_Extensions"; //;getParam()+"KamDUI_Extensions";
	
	homeURL = INET_HOMEPAGEROOT+"index.php";
	
	lastDownloadPath = System.getDownloadPath();
	onDownload = FALSE;
	onDownloadExt = FALSE;
	
	onLoad = 1;
	ibrowser = scriptGroup.getObject("browser");
	
	if (strlower(inetbrowser_homepage_attrib.getData()) == "http://kameleondui.leechbbite.com/home.php") { // fix old bug, double-b ;)
		inetbrowser_homepage_attrib.setData(INET_HOMEPAGE);
	}
	
	urlbox = scriptGroup.getObject("edit.url");
	urlbox.setText(getPrivateString(getSkinName(),"ibrowser url",inetbrowser_homepage_attrib.getData()));
	buttonBack = scriptGroup.getObject("button.back");
	buttonFwd = scriptGroup.getObject("button.forward");
	buttonRefresh = scriptGroup.getObject("button.refresh");
	buttonStop = scriptGroup.getObject("button.stop");
	buttonHome = scriptGroup.getObject("button.home");
	buttonGo = scriptGroup.getObject("button.go");
	buttonLyrics = scriptGroup.getObject("button.lyrics");
	buttonChords = scriptGroup.getObject("button.chords");
	buttonArtistSite = scriptGroup.getObject("button.artistsite");
	
	buttonGo.onLeftClick();
	
	delayURL = new Timer;
	delayURL.setDelay(100);
	
	delayInstallBG = new Timer;
	delayInstallBG.setDelay(500);
	
}

system.onScriptUnloading() {
	ibrowser = NULL;
	delete delayURL;
	delete delayInstallBG;
}

scriptGroup.onSetVisible(int on) {

	if (on) {
		string openPage = inetbrowser_openpage_attrib.getData();
		if (!onDataChg)  // means if not triggered from attrib data change.
			openPage = "";
		
		if (strleft(openPage,5) == "ADDBG") return; // if for adding texture, exit
		
		if (strlower(openPage) == "lyrics") {
			buttonLyrics.onLeftClick();
		} else if (strlower(openPage) == "chords") {
			buttonChords.onLeftClick();
		} else if (strlower(openPage) == "officialsite") {
			buttonArtistSite.onLeftClick();
		} else if (strlower(openPage) == "moreinfo") {
			moreArtistInfo();
		} else if (openPage!="") { // if URL was given
			urlbox.setText(openPage);
			buttonGo.onLeftClick();
		} else {
			urlbox.setText(getPrivateString(getSkinName(),"ibrowser url",inetbrowser_homepage_attrib.getData()));
			buttonGo.onLeftClick();
		}
		//inetbrowser_openpage_attrib.setData("");
	}
}

windows_inet_attrib.onDataChanged() {
	if (!ibrowser) return;
	if (getData()=="0") {
		urlbox.setText(getPrivateString(getSkinName(),"ibrowser url",inetbrowser_homepage_attrib.getData()));
		buttonGo.onLeftClick();
	}
}

// attrib used for outside page request (and texture adding as well)
inetbrowser_openpage_attrib.onDataChanged() {
	if (getData()=="") return;
	
	if (strleft(getData(),5) == "ADDBG") return; // if for adding texture, exit

	guiobject concealer = NULL;
	layout parent = scriptGroup.getParentLayout();
	concealer = parent.findObject("frame.concealer");
	
	onDataChg = 1;
	
	if (!parent.isVisible()) {
		parent.show();
	} else {
		if (windows_inet_attrib.getData()!="1" || !concealer)
			scriptGroup.onSetVisible(1);
	}
	
	onDataChg = 0;
}

buttonGo.onLeftClick() {
	if (!ibrowser) return;
	
	string URLText = urlbox.getText();
	string lowURLText = strupper(URLText);
	string lowInetHome = strupper(INET_HOMEPAGE);
	if (lowURLText != lowInetHome) {
		ibrowser.navigateURL(URLText);
		setPrivateString(getSkinName(),"ibrowser url",URLText);
	} else {
		updateHomePage();
	}
	
}


updateHomePage() {
	string mediatype = "aud";

	boolean isStream = (StrLeft(getPlayItemString(), 7) == "http://") || (StrLeft(getPlayItemString(), 6) == "mms://");

	if (isVideo()) {
		if (isStream) 
			mediatype = "itv";
		else
			mediatype = "vid";
	} else {
		if (isStream) 
			mediatype = "iradio";
		else
			mediatype = "aud";
	}
	
	
	String strQuery = "";
	String strArtist = System.urlEncode(System.getPlayitemMetaDataString("artist"));
	String strAlbum = System.urlEncode(System.getPlayitemMetaDataString("album"));
	String strTitle = System.urlEncode(System.getPlayitemMetaDataString("title"));
	String strYear = System.urlEncode(System.getPlayitemMetaDataString("year"));
	String strGenre = System.urlEncode(System.getPlayitemMetaDataString("genre"));
	String strSCVer = getString("shoutcast.list.update",1001);
	
	strQuery = "v="+ SKIN_VERSION + "&mediatype=" + mediatype + "&artist=" + strArtist + "&album=" + strAlbum + "&title=" +strTitle +
				"&year=" + strYear + "&genre=" + strGenre + "&sc=" + strSCVer;

	ibrowser.navigateURL(homeURL + "?" + strQuery);
	setPrivateString(getSkinName(),"ibrowser url",homeURL + "?" + strQuery);
}

System.onTitleChange(String newtitle) {
	if (last_autotitle == newtitle) return;
	if (StrLeft(newtitle, 1) == "[") {
		if (StrLeft(newtitle, 7) == "[Buffer" ||
		    StrLeft(newtitle, 4) == "[ICY") return;
	}
	
	last_autotitle = newtitle;
	
	// if on home page, auto-update
	string uppInetHome = strupper(INET_HOMEPAGEROOT+"INDEX.PHP");
	string URLText = strleft(urlbox.getText(),strlen(uppInetHome));
	string uppURLText = strupper(URLText);

	if (uppURLText == uppInetHome) {
		updateHomePage();
	}
	
	
	// if on lyrics page, auto-update too
	uppInetHome = strupper(INET_HOMEPAGEROOT+"LYRICS.PHP");
	URLText = strleft(urlbox.getText(),strlen(uppInetHome));
	uppURLText = strupper(URLText);
	
	if (uppURLText == uppInetHome) {
		buttonLyrics.onLeftClick();
	}
}

urlbox.onEnter() {
	if (localChange) return;
	buttonGo.onLeftClick();
}

ibrowser.onDocumentComplete(String url) {
	if (strlower(url)=="about:blank") return;
	localChange = true;
	urlbox.setText(url);
	setPrivateString(getSkinName(),"ibrowser url",url);
	localChange = false;
	
	string lowInetHome = strlower(INET_HOMEPAGE);
	string lowURLText = strleft(strlower(url),strlen(lowInetHome));
	
	if (lowURLText == lowInetHome) { buttonGo.onLeftClick(); return; }
	
	if (strsearch(strlower(url),"installkambg.php") > 0) {
		setPrivateString(getSkinName(),"ibrowser url",INET_HOMEPAGEROOT+"bkgrounds.php");
		string fname = urlDecode(getURLData(url,"file"));
		string tname = urlDecode(getURLData(url,"name"));
		string tile = getURLData(url,"tile");
		string ct = urlDecode(getURLData(url,"ct"));
		
		installTexture(fname, tname, tile, ct);
	}
	
	if (strsearch(strlower(url),"installkamext.php") > 0) {
		setPrivateString(getSkinName(),"ibrowser url",INET_HOMEPAGEROOT+"home.php");
		string fnames = urlDecode(getURLData(url,"files"));
		string extname = urlDecode(getURLData(url,"name"));

		installExtensions(extname, fnames);
	}

}

buttonBack.onLeftClick() {
	if (!ibrowser) return;
	
	ibrowser.back();
}

buttonFwd.onLeftClick() {
	if (!ibrowser) return;
	
	ibrowser.forward();
}

buttonRefresh.onLeftClick() {
	if (!ibrowser) return;
	
	string URLText = urlbox.getText();
	string lowInetHome = strlower(homeURL);
	string lowURLText = strleft(strlower(url),strlen(lowInetHome));
	
	if (lowURLText == lowInetHome)
		buttonHome.onLeftClick();
	else
		ibrowser.refresh();

}

buttonStop.onLeftClick() {
	if (!ibrowser) return;
	
	
	
	ibrowser.stop();
}

buttonHome.onLeftClick() {
	if (!ibrowser) return;
	
	urlbox.setText(inetbrowser_homepage_attrib.getData());
	buttonGo.onLeftClick();
}

buttonLyrics.onLeftClick() {
	if (!ibrowser) return;
	
	string strartist = getPlayItemMetaDataString("artist");
	string strtitle = getPlayItemMetaDataString("title");
	
	urlbox.setText(INET_HOMEPAGEROOT+"lyrics.php?artist="+urlEncode(strartist)+"&title="+urlEncode(strtitle));
	buttonGo.onLeftClick();
}

buttonChords.onLeftClick() {
	if (!ibrowser) return;
	
	string strartist = getPlayItemMetaDataString("artist");
	string strtitle = getPlayItemMetaDataString("title");
	
	if (inetbrowser_Chords_luckymode_attrib.getData()=="1")
		urlbox.setText("http://www.google.com/search?hl=en&q="+urlEncode(strartist+" "+strtitle+" chords")+"&btnI=I%27m+Feeling+Lucky&meta=");
	else
		urlbox.setText("http://www.google.com/search?hl=en&q="+urlEncode(strartist+" "+strtitle+" chords")+"&btnG=Google+Search&meta=");
	buttonGo.onLeftClick();
}

buttonArtistSite.onLeftClick() {
	if (!ibrowser) return;
	
	string strartist = getPlayItemMetaDataString("artist");
	
	if (inetbrowser_info_luckymode_attrib.getData()=="1")
		urlbox.setText("http://www.google.com/search?hl=en&q="+urlEncode(strartist+" official site")+"&btnI=I%27m+Feeling+Lucky&meta=");
	else
		urlbox.setText("http://www.google.com/search?hl=en&q="+urlEncode(strartist+" official site")+"&btnG=Google+Search&meta=");
	buttonGo.onLeftClick();
}

moreArtistInfo() {
	if (!ibrowser) return;
	
	String strArtist = System.urlEncode(System.getPlayitemMetaDataString("artist"));
	String strAlbum = System.urlEncode(System.getPlayitemMetaDataString("album"));
	String strTitle = System.urlEncode(System.getPlayitemMetaDataString("title"));
	String strYear = System.urlEncode(System.getPlayitemMetaDataString("year"));
	String strGenre = System.urlEncode(System.getPlayitemMetaDataString("genre"));
	
	string strQuery = "v="+ SKIN_VERSION + "&artist=" + strArtist + "&album=" + strAlbum + "&title=" +strTitle +
				"&year=" + strYear + "&genre=" + strGenre;

	urlbox.setText(INET_HOMEPAGEROOT + "moreinfo.php?" + strQuery);
	buttonGo.onLeftClick();
}

// ***** install texture scripts ***********

installTexture(string fname, string tname, string tile, string ct) {
	
	if (onDownload) {
		urlbox.setText(INET_HOMEPAGEROOT+"installerror.php");
		buttonGo.onLeftClick();
		return;
	}
	
	textureName = tname;
	textureTile = tile;
	colorTheme = ct;
	
	onDownload = TRUE;
	downloadMedia(INET_HOMEPAGEROOT+"background/"+fname, extPath+"\\textures", 0, 1); // double "\" on path to prevent inserting \t tab.
}

installExtensions(string extname, string fnames) {
	if (onDownloadExt) {
		urlbox.setText(INET_HOMEPAGEROOT+"installerrorext.php");
		buttonGo.onLeftClick();
		return;
	}
	
	onDownloadExt = TRUE;
	
	numExtFiles = 0;
	string currfile;
	do {
		currfile = getToken(fnames, ";", numExtFiles);
		if (currfile!="") {
			downloadMedia(INET_HOMEPAGEROOT+"ext/"+currfile, extPath, 0, 1);
		}
		
		numExtFiles++;
	} while (currfile!="");
	numExtFiles--;
}

System.onDownloadFinished(String url, boolean success, String filename) {
	if (onDownload) {
		onDownload = FALSE;
		
		if (!success) {
			newURL = INET_HOMEPAGEROOT+"installerror.php";
			delayURL.start();
			return;
		}
		
		newBG = "ADDBG;"+filename+"|"+textureName+"|"+textureTile+"|"+colorTheme;
		
		newURL = INET_HOMEPAGEROOT+"bkgrounds.php";
		delayURL.start();
		delayInstallBG.start();
	}
	if (onDownloadExt) {
		if (!success) {
			onDownloadExt = FALSE;
			newURL = INET_HOMEPAGEROOT+"installerror.php";
			delayURL.start();
			return;
		}
		
		if (numExtFiles > 1)
			numExtFiles--;
		else {
			onDownloadExt = FALSE;
			newURL = INET_HOMEPAGEROOT+"installkamextsuccess.php";
			delayURL.start();
		}
	}
}

delayURL.onTimer() {
	stop();
	
	urlbox.setText(newURL);
	buttonGo.onLeftClick();
}

delayInstallBG.onTimer() {
	stop();
	
	setPrivateInt(getSkinName(),"ADDBG",1);
	inetbrowser_openpage_attrib.setData(newBG);
}
