/*************************************************************

  layerhslider-to-attrib.m
  by Leechbite

  general purpose script to make a horizontal slider using 
  2 guiobject layers.
  
  param = "baseID,sliderID,attribGUID;attribName,min,max"
    e.g. param = "slider.base,slider,{F1239F09-8CC6-4081-8519-C2AE99FCB14C};Crossfade time,0,20" 
    
*************************************************************/

#include <lib/std.mi>
#include <lib/config.mi>

Global group scriptGroup;
Global guiObject baseObj, sliderObj;
Global int min, max;
Global configAttribute attrib;
Global boolean mouseDown;

System.onScriptLoaded() {

	scriptGroup = getScriptGroup();
	string param = getParam();
	
	baseObj = scriptGroup.getObject(getToken(param,",",0));
	sliderObj = scriptGroup.getObject(getToken(param,",",1));
	string param3 = getToken(param,",",2);
	
	min = stringToInteger(getToken(param,",",3));
	max = stringToInteger(getToken(param,",",4));
	
	if (max <= min) max = 255;
	
	configItem configGroup = Config.getItemByGuid(getToken(param3,";",0));
	if (configGroup) attrib = configGroup.newAttribute(getToken(param3,";",1),"");
	
	if (attrib) attrib.onDataChanged();
}

attrib.onDataChanged() {
	if (sliderObj) {
		int newdata = stringToInteger(getData());
		int width = newdata*stringToInteger(baseObj.getXMLParam("w"))/(max-min);
		sliderObj.setXMLParam("w", integerToString(width));
	}
}

baseObj.onLeftButtonDown(int x, int y) {
	mouseDown = true;
	
	int newdata = (x-getLeft())*(max-min)/getWidth() + min;
	if (newdata > max) newdata = max;
	if (newdata < min) newdata = min;
		
	if (attrib) attrib.setData(integerToString(newdata));
}

baseObj.onMouseMove(int x, int y) {
	if (!mouseDown) return;
	
	int newdata = (x-getLeft())*(max-min)/getWidth() + min;
	if (newdata > max) newdata = max;
	if (newdata < min) newdata = min;
	
	if (attrib) attrib.setData(integerToString(newdata));
}

baseObj.onLeftButtonUp(int x, int y) {
	mouseDown = false;
}
