/*************************************************************

  KameleonDUI - lcd-control.m
  by Leechbite

  controls the lcd elements, specifically the songticker/timer combo
  

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

Global text songticker,artist, timertxt;
Global string artistOrigW, artistExpandedW, artistFullW, songtickerOrigW;

System.onScriptLoaded() {
	initAttribs();
	
	group scriptGroup = getScriptGroup();
	string param = getParam();

	songticker = scriptGroup.getObject(getToken(param,",",0));
	artist = scriptGroup.getObject(getToken(param,",",1));
	timertxt = scriptGroup.getObject(getToken(param,",",2));
	
	artistOrigW = artist.getXMLParam("w");
	artistExpandedW = getToken(param,",",3);
	artistFullW = getToken(param,",",4);
	
	timer_style_000_00_00_attrib.onDataChanged();
}

System.onScriptUnloading() {
	return;
}

timer_style_000_00_00_attrib.onDataChanged() {
	if (!timertxt.isVisible()) {
		artist.setXMLParam("w",artistFullW);
		return;
	}
	
	if (getData()=="1") {
		artist.setXMLParam("w",artistOrigW);
	} else {
		artist.setXMLParam("w",artistExpandedW);
	}
	
}

timertxt.onSetVisible(int on) {
	timer_style_000_00_00_attrib.onDataChanged();
}


