/*************************************************************

  lcd-srx.m
  by Leechbite

  script to display shuffle, repeat, and crossfade status on a text obj.
  
  param = "textID"
  
*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

Global group scriptGroup;
Global text textobj;
Global timer refreshTimer;

System.onScriptLoaded() {
	initAttribs();

	scriptGroup = getScriptGroup();
	string param = getParam();
	
	textobj = scriptGroup.getObject(getToken(param,",",0));
	
	attrShuffle.onDataChanged();
	
	refreshTimer = new Timer;
	refreshTimer.setDelay(200);
	refreshTimer.start();
}

System.onScriptUnloading() {
	delete refreshTimer;
}

refreshTimer.onTimer() {
	textobj.setText(getSongInfoText());
}

System.onStatusMsg(String msg) {
	textobj.setText(msg);
}

