/*************************************************************

  lcd-srx.m
  by Leechbite

  script to display shuffle, repeat, and crossfade status on a text obj.
  
  param = "textID"
  
*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

Global group scriptGroup;
Global text textobj;

System.onScriptLoaded() {
	initAttribs();

	scriptGroup = getScriptGroup();
	string param = getParam();
	
	textobj = scriptGroup.getObject(getToken(param,",",0));
	
	attrShuffle.onDataChanged();
}

attrShuffle.onDataChanged() {
	if (!textobj) return;
	
	string shftxt = "SHF OFF";
	string reptxt = "REP OFF";
	string xfdtxt = "XFD OFF";
	
	if (getData()=="1")
		shftxt = "SHF ON ";
	if (attrRepeat.getData()=="1")
		reptxt = "REP ALL";
	else if (attrRepeat.getData()=="-1")
		reptxt = "REP TRK";
	if (attrXfade.getData()=="1")
		xfdtxt = "XFD ON ";
		
	textobj.setText(shftxt+"  "+reptxt+"  "+xfdtxt);
}

attrRepeat.onDataChanged() { attrShuffle.onDataChanged(); }
attrXfade.onDataChanged() { attrShuffle.onDataChanged(); }