/****************

KameleonDUI - main script

the system script for the whole skin.


****************/

#include "../../../lib/std.mi"
#include "../../../lib/config.mi"
#include "attribs.m"
#include "utilities.m"
#include "eq-utilities.m"

Global container mainCont;
Global layout mainLayout, shadeLayout;

Global int lastVol;
Global boolean muteVolChange = false;
Global mouseredir t;

System.onScriptLoaded() {

	initAttribs();

	mainCont = getContainer("main");
	mainLayout = mainCont.getLayout("normal");
	shadeLayout = mainCont.getLayout("shade");
	
	lastVol = getVolume();
	vol_mute_attrib.setData("0");
	
	setPrivateString(getSkinName(),"ibrowser url",inetbrowser_homepage_attrib.getData()); // reset to homepage on start
	
	setTempText("LEECHBITE.COM|KAMELEON-DUI");
}

System.onScriptUnloading() {
	setPrivateInt(getSkinName(),"OpenLastSessionPL",windows_pl_attrib.getData()=="1" && isNamedWindowVisible(PL_GUID));
	setPrivateString("KameleonDUI","MoreBkgrounds",""); // will be set in the future through external xml/scripts, but has to be reset
														// every unload for stability.
}


mainCont.onSwitchToLayout(layout newlay) {
	if (newlay == shadeLayout) {
		if (shadeLayout.getTop() < 0) // if shade layout not on screen, move down to make it visible.
			shadeLayout.resize(shadeLayout.getLeft(),0,shadeLayout.getWidth(), shadeLayout.getHeight());
	}
}

system.onVolumeChanged(int newvol) {
	if (muteVolChange) return;
	
	if (vol_mute_attrib.getData()=="1") {
		if (vol_attmode_attrib.getData()=="1") {
			if (newvol == (lastVol*0.1)) 
				setTempText("Attenuate");
			else 
				vol_mute_attrib.setData("0");
		} else {
			if (newvol == 0) 
				setTempText("Mute");
			else
				vol_mute_attrib.setData("0");
		}
	} else
		setTempText("Volume: "+integerToString(newvol*100/255)+"%");
}

System.onPlay() {
    setTempText("Play");
}

System.onresume() {
    setTempText("Resume Play");
}

System.onPause() {
	setTempText("Pause");
}

System.onStop() {
	setTempText("Stop");
}

vol_mute_attrib.onDataChanged() {
	if (getData()=="1") {
		lastVol = getVolume();
		muteVolChange = true;
		if (vol_attmode_attrib.getData()=="1") {
			setVolume(lastVol*0.1);
		} else {
			setVolume(0);
		}
		muteVolChange = false;
	} else {
		setVolume(lastVol);
	}
}

attrRepeat.onDataChanged() {
	if (getData()=="-1")
		setTempText("Repeat Track");
	else if (getData()=="1")
		setTempText("Repeat Playlist");
	else
		setTempTExt("Repeat Off");
}

attrShuffle.onDataChanged() {
	if (getData()=="1")
		setTempText("Shuffle On");
	else
		setTempText("Shuffle Off");
}

attrXfade.onDataChanged() {
	if (temptext_attrib.getData() == "LEECHBITE.COM|KAMELEON-DUI") return;
	if (getData()=="1")
		setTempText("Crossfading On");
	else
		setTempText("Crossfading Off");
}

// *********** Common EQ Scripts **************
system.onEQBandChanged(int band, int newvalue) {
	
	if (!getEQ()) {
		eq_presetname_attrib.setData("Off");
		return;
	}
	
	string eqName = "CUSTOM";

	if (isEQEqualTo(EQ_Flat)) eqName = "FLAT";
	else if (isEQEqualTo(EQ_Rock)) eqName = "ROCK";
	else if (isEQEqualTo(EQ_Full)) eqName = "FULL";
	else if (isEQEqualTo(EQ_Pop)) eqName = "POP";
	else if (isEQEqualTo(EQ_Soft)) eqName = "SOFT";
	else if (isEQEqualTo(EQ_Techno)) eqName = "TECHNO";
	else if (isEQEqualTo(EQ_Reggae)) eqName = "REGGAE";
	else if (isEQEqualTo(EQ_Classical)) eqName = "CLASSICAL";
	else if (isEQEqualTo(EQ_Dance)) eqName = "DANCE";
	else if (isEQEqualTo(EQ_Ska)) eqName = "SKA";
	else if (isEQEqualTo(EQ_SoftRock)) eqName = "Soft Rock";
	else {
		int eqUser0 = getPrivateInt(getSkinName(), "User EQ 0", 1);
		int eqUser1 = getPrivateInt(getSkinName(), "User EQ 1", 1);
		int eqUser2 = getPrivateInt(getSkinName(), "User EQ 2", 1);
		int eqUser3 = getPrivateInt(getSkinName(), "User EQ 3", 1);
		int eqUser4 = getPrivateInt(getSkinName(), "User EQ 4", 1);
		int eqUser5 = getPrivateInt(getSkinName(), "User EQ 5", 1);
		int eqUser6 = getPrivateInt(getSkinName(), "User EQ 6", 1);
		int eqUser7 = getPrivateInt(getSkinName(), "User EQ 7", 1);
		int eqUser8 = getPrivateInt(getSkinName(), "User EQ 8", 1);
		int eqUser9 = getPrivateInt(getSkinName(), "User EQ 9", 1);
		int eqUserPreamp = getPrivateInt(getSkinName(), "User EQ Preamp", 1);
		if(isEQEqualTo(eqUserPreamp, eqUser0, eqUser1, eqUser2, 
			eqUser3, eqUser4, eqUser5, eqUser6, eqUser7, eqUser8, eqUser9)) eqName = "USER";
	}
	
	eq_presetname_attrib.setData(eqName);
}

system.onEQPreampChanged(int newval) {
	system.onEQBandChanged(0,0); // refresh eq_presetname_attrib
}

system.onEQChanged(int newstat) {
	system.onEQBandChanged(0,0); // refresh eq_presetname_attrib
}

system.onKeyDown(string keypressed) {
	keypressed = strlower(keypressed);
	
	if (keypressed == "alt+g") {
		layout eqLayout = getContainer("EQ").getLayout("normal");
		
		if (eqLayout.isVisible())
			eqLayout.hide();
		else
			eqLayout.show();
	}
}