/*************************************************************

  KameleonDUI - menu-beatvis.m
  by Leechbite

  Create a right-click activated menu for beat vis options
  
  param = "objID,objID2"

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

Global group scriptGroup;
Global guiObject obj1, obj2;

System.onScriptLoaded() {
	initAttribs();

	scriptGroup = getScriptGroup();
	string param = getParam();
	
	obj1 = scriptGroup.getObject(getToken(param,",",0));
	obj2 = scriptGroup.getObject(getToken(param,",",1));
	
}

obj1.onRightButtonDown(int x, int y) {
	string lasttip = getXMLParam("tooltip");

	popupMenu beatMenu = new popupMenu;

	beatMenu.addCommand("- Beat Vis -", -1, 0, 1);
	beatMenu.addSeparator();
	beatMenu.addCommand(" Off", 0, beat_off_attrib.getData()=="1", 0);
	beatMenu.addCommand(" VU Meter", 1, beat_srcVU_attrib.getData()=="1", 0);
	beatMenu.addCommand(" Bass", 2, beat_srcBass_attrib.getData()=="1", 0);
	beatMenu.addCommand(" Treble", 3, beat_srcTreble_attrib.getData()=="1", 0);
		
	int res = beatMenu.popAtMouse();
	delete beatMenu;
	
	if (res == 0) {
		beat_off_attrib.setData("1");
	} else if (res == 1) {
		beat_srcVU_attrib.setData("1");
	} else if (res == 2) {
		beat_srcBass_attrib.setData("1");
	} else if (res == 3) {
		beat_srcTreble_attrib.setData("1");
	}
	
	obj1.setXMLParam("tooltip",lasttip);
	
	complete;
}

obj2.onRightButtonDown(int x, int y) {
	string lasttip2 = getXMLParam("tooltip");
	
	obj1.onRightButtonDown(0,0);
	
	obj2.setXMLParam("tooltip",lasttip2);
	complete;
}

