/*************************************************************

  KameleonDUI - menu-config.m
  by Leechbite

  Create a right-click skin options menu.
  
  param = "objID"

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

Global group scriptGroup;
Global guiObject obj;

System.onScriptLoaded() {
	initAttribs();
	
	scriptGroup = getScriptGroup();
	string param = getParam();
	
	string objID = getToken(getToken(param,",",0),";",0);
	string objID2 = getToken(getToken(param,",",0),";",1);
	
	if (objID2 == "")
		obj = scriptGroup.getObject(objID);
	else {
		group temp = scriptGroup.getObject(objID);
		obj = temp.getObject(objID2); 
	}
	
}

obj.onRightButtonDown(int x, int y) {
	string lasttip = getXMLParam("tooltip");

	popupMenu windowsMenu = new popupMenu;
	configAttribute duiAttrib;

	windowsMenu.addCommand("DUI Tab Mode", 1001, windows_duitab_attrib.getData()=="1", 0);
	windowsMenu.addCommand("Detach windows on shade mode", 1002, windows_detachonshade_attrib.getData()=="1", 0);
	windowsMenu.addCommand("Hide/Show windows on resize", 1003, windows_hideshowonresize_attrib.getData()=="1", 0);
	windowsMenu.addSeparator();
	
	string windowList = getPrivateString(getSkinName(), "DUI Window List", "");
	int c = 0;
	string winName = "";
	do {
		winName = getToken(windowList, ",", c);
		if (winName!="") {
			duiAttrib = NULL;
			duiAttrib = custom_page_windows.getAttribute("Attach "+winName+" window");
			if (duiAttrib) windowsMenu.addCommand("Attach "+winName+" window", 100+c, duiAttrib.getData()=="1", 0);
		}
		c++;
	} while (winName!="");
	
	popupMenu timerMenu = new popupMenu;
	
	timerMenu.addCommand(" 000:00:00", 200, timer_style_000_00_00_attrib.getData()=="1", 0);
	timerMenu.addCommand(" 000:00", 201, timer_style_000_00_attrib.getData()=="1", 0);
	timerMenu.addSeparator();
	timerMenu.addCommand(" Remaining", 202, timer_remain_attrib.getData()=="1", 0);
	timerMenu.addCommand(" Elapsed", 203, timer_elapsed_attrib.getData()=="1", 0);

	popupMenu muteMenu = new popupMenu;

	muteMenu.addCommand(" Attenuate", 300, vol_attmode_attrib.getData()=="1", 0);
	muteMenu.addCommand(" Mute", 301, vol_mutemode_attrib.getData()=="1", 0);
	
	popupMenu wheelMenu = new popupMenu;
	
	wheelMenu.addCommand(" Volume \tSHFT-click", 401, wheel_vol_attrib.getData()=="1", 0);
	wheelMenu.addCommand(" Seeker \tCTRL-click", 402, wheel_seek_attrib.getData()=="1", 0);
	wheelMenu.addCommand(" Bass \tSHFT-CTRL-click", 403, wheel_bass_attrib.getData()=="1", 0);
	wheelMenu.addCommand(" Treble \tCTRL-ALT-click", 404, wheel_treble_attrib.getData()=="1", 0);
	wheelMenu.addCommand(" Balance \tALT-click", 405, wheel_bal_attrib.getData()=="1", 0);
	
	popupMenu songtickerMenu = new popupMenu;
	
	songtickerMenu.addCommand(" No Scroll", 501, songticker_scroll_attrib.getData()=="1", 0);
	songtickerMenu.addCommand(" Scroll", 502, songticker_noscroll_attrib.getData()=="1", 0);

	popupMenu beatMenu = new popupMenu;

	beatMenu.addCommand(" Off", 600, beat_off_attrib.getData()=="1", 0);
	beatMenu.addCommand(" VU Meter", 601, beat_srcVU_attrib.getData()=="1", 0);
	beatMenu.addCommand(" Bass", 602, beat_srcBass_attrib.getData()=="1", 0);
	beatMenu.addCommand(" Treble", 603, beat_srcTreble_attrib.getData()=="1", 0);

	popupMenu inetMenu = new popupMenu;

	inetMenu.addCommand(" Chords Lucky Search", 901, inetbrowser_chords_luckymode_attrib.getData()=="1", 0);
	inetMenu.addCommand(" Artist Info Lucky Search", 902, inetbrowser_info_luckymode_attrib.getData()=="1", 0);
	
	popupMenu cdcoverMenu = new popupMenu;

	cdcoverMenu.addCommand(" Auto-download (Amazon.com)", 700, cdcover_autodownload_attrib.getData()=="1", 0);
	cdcoverMenu.addSeparator();
	cdcoverMenu.addCommand(" Cover Size: 1x", 701, cdcover_size_1x_attrib.getData()=="1", 0);
	cdcoverMenu.addCommand(" Cover Size: Full", 702, cdcover_size_full_attrib.getData()=="1", 0);
	cdcoverMenu.addCommand(" Cover Size: Custom", 703, cdcover_size_custom_attrib.getData()=="1", 0);

	popupMenu notifierMenu = new popUpMenu;
	notifierMenu.addCommand(notifier_always_attrib.getAttributeName(), 801, notifier_always_attrib.getData()=="1", 0);
	notifierMenu.addCommand(notifier_windowshade_attrib.getAttributeName(), 802, notifier_windowshade_attrib.getData()=="1", 0);
	notifierMenu.addCommand(notifier_minimized_attrib.getAttributeName(), 803, notifier_minimized_attrib.getData()=="1", 0);
	notifierMenu.addCommand(notifier_never_attrib.getAttributeName(), 804, notifier_never_attrib.getData()=="1", 0);
	notifierMenu.addSeparator();
	notifierMenu.addCommand(notifier_location_topright_attrib.getAttributeName(), 805, notifier_location_topright_attrib.getData()=="1", 0);
	notifierMenu.addCommand(notifier_location_topleft_attrib.getAttributeName(), 806, notifier_location_topleft_attrib.getData()=="1", 0);
	notifierMenu.addCommand(notifier_location_bottomright_attrib.getAttributeName(), 807, notifier_location_bottomright_attrib.getData()=="1", 0);
	notifierMenu.addCommand(notifier_location_bottomleft_attrib.getAttributeName(), 808, notifier_location_bottomleft_attrib.getData()=="1", 0);
	notifierMenu.addSeparator();
	notifierMenu.addCommand(notifier_noanim_attrib.getAttributeName(), 809, notifier_noanim_attrib.getData()=="1", 0);
	notifierMenu.addCommand(notifier_anim_fade_attrib.getAttributeName(), 810, notifier_anim_fade_attrib.getData()=="1", 0);
	notifierMenu.addCommand(notifier_anim_slidevert_attrib.getAttributeName(), 811, notifier_anim_slidevert_attrib.getData()=="1", 0);
	notifierMenu.addCommand(notifier_anim_slidehort_attrib.getAttributeName(), 812, notifier_anim_slidehort_attrib.getData()=="1", 0);
	notifierMenu.addSeparator();
	notifierMenu.addCommand(notifier_cdcover_attrib.getAttributeName(), 813, notifier_cdcover_attrib.getData()=="1", 0);
	notifierMenu.addCommand(notifier_disablefullscreen_attrib.getAttributeName(), 814, notifier_disablefullscreen_attrib.getData()=="1", 0);
	notifierMenu.addCommand(notifier_showend_attrib.getAttributeName(), 815, notifier_showend_attrib.getData()=="1", 0);
	
	// *** parent menu
	popupMenu skinoptionsMenu = new popupMenu;
	
	skinoptionsMenu.addSubMenu(windowsMenu,"Windows");
	skinoptionsMenu.addSubMenu(timerMenu,"Timer");
	skinoptionsMenu.addSubMenu(muteMenu,"Mute Mode");
	skinoptionsMenu.addSubMenu(wheelMenu,"Wheel Mode");
	skinoptionsMenu.addSubMenu(songtickerMenu,"Songticker");
	skinoptionsMenu.addSubMenu(beatMenu,"Beat Vis");
	skinoptionsMenu.addSubMenu(inetMenu,"Internet Browser");
	skinoptionsMenu.addSubMenu(cdcoverMenu,"CD Cover Art");
	skinoptionsMenu.addSubMenu(notifierMenu,"Notifications");

	
	int res = skinoptionsMenu.popAtMouse();
	
	delete windowsMenu;
	delete timerMenu;
	delete muteMenu;
	delete wheelMenu;
	delete songtickerMenu;
	delete beatMenu;
	delete inetMenu;
	delete cdcoverMenu;
	delete notifierMenu;
	delete skinoptionsMenu;
	
	if (res >= 100 && res < 200) {
		c = res - 100;
		winName = getToken(windowList, ",", c);
		if (winName!="") {
			duiAttrib = NULL;
			duiAttrib = custom_page_windows.getAttribute("Attach "+winName+" window");
			if (duiAttrib) duiAttrib.setData(integerToString(duiAttrib.getData()=="0"));
		}
	}
	else if (res == 1001) windows_duitab_attrib.setData(integerToString(windows_duitab_attrib.getData()=="0"));
	else if (res == 1002) windows_detachonshade_attrib.setData(integerToString(windows_detachonshade_attrib.getData()=="0"));
	else if (res == 1003) windows_hideshowonresize_attrib.setData(integerToString(windows_hideshowonresize_attrib.getData()=="0"));
	else if (res == 200) timer_style_000_00_00_attrib.setData("1");
	else if (res == 201) timer_style_000_00_attrib.setData("1");
	else if (res == 202) timer_remain_attrib.setData("1");
	else if (res == 203) timer_elapsed_attrib.setData("1");
	
	else if (res == 300) vol_attmode_attrib.setData("1");
	else if (res == 301) vol_mutemode_attrib.setData("1");

	else if (res == 401) wheel_vol_attrib.setData("1");
	else if (res == 402) wheel_seek_attrib.setData("1");
	else if (res == 403) wheel_bass_attrib.setData("1");
	else if (res == 404) wheel_treble_attrib.setData("1");
	else if (res == 405) wheel_bal_attrib.setData("1");
	
	else if (res == 501) songticker_scroll_attrib.setData("1");
	else if (res == 502) songticker_noscroll_attrib.setData("1");

	else if (res == 600) beat_off_attrib.setData("1");
	else if (res == 601) beat_srcVU_attrib.setData("1");
	else if (res == 602) beat_srcBass_attrib.setData("1");
	else if (res == 603) beat_srcTreble_attrib.setData("1");
	
	else if (res == 700) cdcover_autodownload_attrib.setData(integerToString(cdcover_autodownload_attrib.getData()=="0"));
	else if (res == 701) cdcover_size_1x_attrib.setData("1");
	else if (res == 702) cdcover_size_full_attrib.setData("1");
	else if (res == 703) cdcover_size_custom_attrib.setData("1");
	
	else if (res == 801) notifier_always_attrib.setData("1");
	else if (res == 802) notifier_windowshade_attrib.setData("1");
	else if (res == 803) notifier_minimized_attrib.setData("1");
	else if (res == 804) notifier_never_attrib.setData("1");
	else if (res == 805) notifier_location_topright_attrib.setData("1");
	else if (res == 806) notifier_location_topleft_attrib.setData("1");
	else if (res == 807) notifier_location_bottomright_attrib.setData("1");
	else if (res == 808) notifier_location_bottomleft_attrib.setData("1");
	else if (res == 809) notifier_noanim_attrib.setData("1");
	else if (res == 810) notifier_anim_fade_attrib.setData("1");
	else if (res == 811) notifier_anim_slidevert_attrib.setData("1");
	else if (res == 812) notifier_anim_slidehort_attrib.setData("1");
	else if (res == 813) notifier_cdcover_attrib.setData(integerToString(notifier_cdcover_attrib.getData()=="0"));
	else if (res == 814) notifier_disablefullscreen_attrib.setData(integerToString(notifier_disablefullscreen_attrib.getData()=="0"));
	else if (res == 815) notifier_showend_attrib.setData(integerToString(notifier_showend_attrib.getData()=="0"));
	
	else if (res == 901) inetbrowser_chords_luckymode_attrib.setData(integerToString(inetbrowser_chords_luckymode_attrib.getData()=="0"));
	else if (res == 902) inetbrowser_info_luckymode_attrib.setData(integerToString(inetbrowser_info_luckymode_attrib.getData()=="0"));

	obj.setXMLParam("tooltip",lasttip);
	
	complete;
}
