/*************************************************************

  KameleonDUI - menu-eq.m
  by Leechbite

  Create a right-click activated menu for EQ controls/presets.
  
  param = "objID"

*************************************************************/

#include <lib/std.mi>
#include "eq-utilities.m"

Global group scriptGroup;
Global guiObject obj;

System.onScriptLoaded() {

	scriptGroup = getScriptGroup();
	string param = getParam();
	
	string objID = getToken(getToken(param,",",0),";",0);
	string objID2 = getToken(getToken(param,",",0),";",1);
	
	if (objID2 == "")
		obj = scriptGroup.getObject(objID);
	else {
		group temp = scriptGroup.getObject(objID);
		obj = temp.getObject(objID2); 
	}
	
}

obj.onRightButtonDown(int x, int y) {
	string lasttip = getXMLParam("tooltip");

	button autoButton = getContainer("eq").getLayout("normal").findObject("eq.button.auto");
		
	popupMenu EQMenu = new popupMenu;

	EQMenu.addCommand("- Equalizer Control -", -1, 0, 1);
	EQMenu.addSeparator();
	EQMenu.addCommand(" EQ On", 0, getEQ(), 0);
	EQMenu.addCommand(" Auto EQ", 1, autoButton.getActivated()==1, 0);
	EQMenu.addSeparator();
	EQMenu.addCommand("- Presets -", -1, 0, 1);
	EQMenu.addSeparator();
	EQMenu.addCommand(" Full", 11, 0, 0);
	EQMenu.addCommand(" Rock", 12, 0, 0);
	EQMenu.addCommand(" Pop", 13, 0, 0);
	EQMenu.addCommand(" Soft", 14, 0, 0);
	EQMenu.addCommand(" Dance", 15, 0, 0);
	EQMenu.addCommand(" USER", 16, 0, 0);
	
	int res = EQMenu.popAtMouse();
	delete EQMenu;
	
	if (res == 0) {
		setEQ(!getEQ());
	} else if (res == 1) {
		autoButton.leftClick();
	} else if (res == 11) {
		setEQPreset(EQ_Full);
	} else if (res == 12) {
		setEQPreset(EQ_Rock);
	} else if (res == 13) {
		setEQPreset(EQ_Pop);
	} else if (res == 14) {
		setEQPreset(EQ_Soft);
	} else if (res == 15) {
		setEQPreset(EQ_Dance);
	} else if (res == 16) {
		setEQPresetUSER();
	}
	
	
	obj.setXMLParam("tooltip",lasttip);
	
	complete;
}

