/*************************************************************

  KameleonDUI - menu-lcd.m
  by Leechbite

  button control script for lcd modes.
  
  param = "customObjID,buttonID,maxLayouts"

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

function setLCDMode(int mode);


Global group scriptGroup;
Global guiObject customObj;
Global button switchButton;
Global int maxLayouts;

System.onScriptLoaded() {
	initAttribs();

	scriptGroup = getScriptGroup();
	string param = getParam();
	
	customObj = scriptGroup.findObject(getToken(param,",",0));
	
	string objID = getToken(getToken(param,",",1),";",0);
	string objID2 = getToken(getToken(param,",",1),";",1);
	
	if (objID2 == "")
		switchButton = scriptGroup.getObject(objID);
	else {
		group temp = scriptGroup.getObject(objID);
		switchButton = temp.getObject(objID2); 
	}
	
	setLCDMode(getPrivateInt(getSkinName(),"lcdmode",1));
	
	maxLayouts = stringToInteger(getToken(param,",",2));
}

switchButton.onRightButtonDown(int x, int y) {
	string lasttip = getXMLParam("tooltip");

	popupMenu lcdMenu = new popupMenu;
	
	int lcdMode = getPrivateInt(getSkinName(),"lcdmode",1);

	lcdMenu.addCommand("- LCD Mode-", -1, 0, 1);
	lcdMenu.addSeparator();
	lcdMenu.addCommand(" Default", 1, lcdMode==1, 0);
	lcdMenu.addCommand(" Small Vis", 2, lcdMode==2, 0);
	lcdMenu.addCommand(" Big Vis", 3, lcdMode==3, 0);
	lcdMenu.addCommand(" Digital Clock", 4, lcdMode==4, 0);
	lcdMenu.addCommand(" Analog Clock", 5, lcdMode==5, 0);
	
		
	int res = lcdMenu.popAtMouse();
	delete lcdMenu;
	
	if (res >= 0) setLCDMode(res);
	
	setXMLParam("tooltip",lasttip);
	
	complete;
}

switchButton.onLeftClick() {
	int lcdMode = getPrivateInt(getSkinName(),"lcdmode",0);
	
	lcdMode++;
	if (lcdMode > maxLayouts) lcdMode = 1;
	
	setLCDMode(lcdMode);
}

setLCDMode(int mode) {
	setPrivateInt(getSkinName(),"lcdmode",mode);
	
	customObj.setXMLParam("groupid","player.main.lcd.layout"+integerToString(mode));
}