/*************************************************************

  KameleonDUI - menu-toggle.m
  by Leechbite

  Create a left-click activated menu list of all the windows/components.
  
  param = "objID"

*************************************************************/

#include <lib/std.mi>

Global group scriptGroup;
Global guiObject obj;


System.onScriptLoaded() {

	scriptGroup = getScriptGroup();
	string param = getParam();
	
	string objID = getToken(getToken(param,",",0),";",0);
	string objID2 = getToken(getToken(param,",",0),";",1);
	
	if (objID2 == "")
		obj = scriptGroup.getObject(objID);
	else {
		group temp = scriptGroup.getObject(objID);
		obj = temp.getObject(objID2); 
	}
	
}

obj.onLeftButtonDown(int x, int y) {
	string lasttip = getXMLParam("tooltip");
	
	layout configlayout = getContainer("config").getLayout("normal");
	layout eqlayout = getContainer("EQ").getLayout("normal");
	layout cdcoverlayout = getContainer("cdcover").getLayout("normal");
	layout ibrowserlayout = getContainer("ibrowser").getLayout("normal");
	
	popUpMenu toggleMenu = new popupMenu;
	toggleMenu.addCommand("  - Components Menu -", -1, 0, 1);
	toggleMenu.addSeparator();
	toggleMenu.addCommand(" Playlist Editor", 1, isNamedWindowVisible("{45F3F7C1-A6F3-4EE6-A15E-125E92FC3F8D}"), 0);
	toggleMenu.addCommand(" Media Library", 2, isNamedWindowVisible("{6B0EDF80-C9A5-11D3-9F26-00C04F39FFC6}"), 0);
	toggleMenu.addCommand(" Video", 3, isNamedWindowVisible("{F0816D7B-FFFC-4343-80F2-E8199AA15CC3}"), 0);
	toggleMenu.addCommand(" Visualizations", 4, isNamedWindowVisible("{0000000A-000C-0010-FF7B-01014263450C}"), 0);
	toggleMenu.addCommand(" Equalizer", 5, eqLayout.isVisible(), 0);
	toggleMenu.addCommand(" Internet Browser", 6, ibrowserlayout.isVisible(), 0);
	toggleMenu.addCommand(" CD Art", 7, cdcoverLayout.isVisible(), 0);
	toggleMenu.addCommand(" Config Panel", 8, configlayout.isVisible(), 0);
	
	int res = toggleMenu.popAtMouse();
	delete toggleMenu;
	
	if (res == 1) {
		if (isNamedWindowVisible("{45F3F7C1-A6F3-4EE6-A15E-125E92FC3F8D}"))
			hideNamedWindow("{45F3F7C1-A6F3-4EE6-A15E-125E92FC3F8D}");
		else
			showWindow("{45F3F7C1-A6F3-4EE6-A15E-125E92FC3F8D}","",1);
	} else if (res == 2) {
		if (isNamedWindowVisible("{6B0EDF80-C9A5-11D3-9F26-00C04F39FFC6}"))
			hideNamedWindow("{6B0EDF80-C9A5-11D3-9F26-00C04F39FFC6}");
		else
			showWindow("{6B0EDF80-C9A5-11D3-9F26-00C04F39FFC6}","",1);
	} else if (res == 3) {
		if (isNamedWindowVisible("{F0816D7B-FFFC-4343-80F2-E8199AA15CC3}"))
			hideNamedWindow("{F0816D7B-FFFC-4343-80F2-E8199AA15CC3}");
		else
			showWindow("{F0816D7B-FFFC-4343-80F2-E8199AA15CC3}","",1);
	} else if (res == 4) {
		if (isNamedWindowVisible("{0000000A-000C-0010-FF7B-01014263450C}"))
			hideNamedWindow("{0000000A-000C-0010-FF7B-01014263450C}");
		else
			showWindow("{0000000A-000C-0010-FF7B-01014263450C}","",1);
	} else if (res == 5) {
		if (eqlayout.isVisible())
			eqlayout.hide();
		else
			eqlayout.show();
	} else if (res == 6) {
		if (ibrowserlayout.isVisible())
			ibrowserlayout.hide();
		else
			ibrowserlayout.show();
	} else if (res == 7) {
		if (cdcoverlayout.isVisible())
			cdcoverlayout.hide();
		else
			cdcoverlayout.show();
	} else if (res == 8) {
		if (configlayout.isVisible())
			configlayout.hide();
		else
			configlayout.show();
	}
	
	obj.setXMLParam("tooltip",lasttip);
}

