/*************************************************************

  KameleonDUI - menu-vis.m
  by Leechbite

  Create a right-click activated menu for vis options
  
  param = "visID,baseID,vis"

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

function setVisMode(int mode);


Global group scriptGroup;
Global vis visObj,visObjThin;
Global guiObject base;

System.onScriptLoaded() {
	initAttribs();

	scriptGroup = getScriptGroup();
	string param = getParam();
	
	visObj = scriptGroup.getObject(getToken(param,",",0));
	visObjThin = scriptGroup.getObject(getToken(param,",",1));
	base = scriptGroup.getObject(getToken(param,",",2));
	
	setVisMode(getPrivateInt(getSkinName(),"vismode",0));
	
}

base.onRightButtonDown(int x, int y) {
	string lasttip = getXMLParam("tooltip");

	popupMenu visMenu = new popupMenu;
	
	int visMode = getPrivateInt(getSkinName(),"vismode",0);

	visMenu.addCommand("- Vis Menu-", -1, 0, 1);
	visMenu.addSeparator();
	visMenu.addCommand(" Off", 0, visMode==0, 0);
	visMenu.addCommand(" Spectrum Analyzer (Thick)", 1, visMode==1, 0);
	visMenu.addCommand(" Spectrum Analyzer (Thin)", 2, visMode==2, 0);
	visMenu.addCommand(" Oscilloscope (Line)", 3, visMode==3, 0);
	visMenu.addCommand(" Oscilloscope (Dots)", 4, visMode==4, 0);
		
	int res = visMenu.popAtMouse();
	delete visMenu;
	
	if (res >= 0) setVisMode(res);
	
	setXMLParam("tooltip",lasttip);
	
	complete;
}

base.onLeftButtonDown(int x, int y) {
	int visMode = getPrivateInt(getSkinName(),"vismode",0);
	
	visMode++;
	if (visMode > 4) visMode = 0;
	
	setVisMode(visMode);
}

setVisMode(int mode) {
	setPrivateInt(getSkinName(),"vismode",mode);
	
	visObjThin.hide();
	visObj.show();
	if (mode == 0) {
		visObj.setMode(0);
	} else if (mode == 1) {
		visObj.setXMLParam("bandwidth","thick");
		visObj.setMode(1);
	} else if (mode == 2) {
		visObjThin.show();
		visObj.hide();
	} else if (mode == 3) {
		visObj.setXMLParam("oscstyle","lines");
		visObj.setMode(2);
	} else if (mode == 4) {
		visObj.setXMLParam("oscstyle","dots");
		visObj.setMode(2);
	}
}