/*************************************************************

  KameleonDUI - player-main-progtoggle.m
  by Leechbite

  specific script to control the group "player.main.buttons.prog.and.toggle"
  this switches from programmable buttons or the toggle buttons.

  
*************************************************************/

#include <lib/std.mi>
#include "utilities.m"

Global group parentGroup;
Global group progGroup, toggleGroup;
Global button switcher;
Global guiobject switcherbase, sep;

System.onScriptLoaded() {
	parentGroup = getScriptGroup();

	progGroup = parentGroup.getObject("player.main.progbuttons");
	toggleGroup = parentGroup.getObject("player.main.button.toggle.horizontal");
	switcher = findXUIObject(parentGroup,"switcher","xuibutton");
	switcherbase = parentGroup.getObject("switcher.base");
	sep = parentGroup.getObject("separator");
	
	parentGroup.onResize(parentGroup.getLeft(),parentGroup.getTop(),
						parentGroup.getWidth(),parentGroup.getHeight());
						
}

parentGroup.onResize(int x, int y, int w, int h) {
	int priority = getPrivateInt(getSkinName(), "Prog Or Toggle Priority", 0); // 0 - for toggle buttons priority; 1 - for prog buttons priority
	sep.hide();
	if (h > 200) {
		toggleGroup.hide();
		progGroup.setXMLParam("w","-247");
		progGroup.show();
		switcher.getParent().hide();
		switcherbase.hide();
	} else {
		if (w > 800) {
			toggleGroup.setXMLParam("x","-321");
			toggleGroup.setXMLParam("w","281");
			toggleGroup.show();
			progGroup.setXMLParam("w","-540");
			progGroup.show();
			switcher.getParent().hide();
			switcherbase.hide();
			sep.show();
		} else if (priority == 0) { // prioritize toggle buttons
			toggleGroup.show();
			if ((w - 270) < 281) {
				toggleGroup.setXMLParam("x",integerToString(-w+270-40));
				toggleGroup.setXMLParam("w",integerToString(w-270));
			} else {
				toggleGroup.setXMLParam("x","-321");
				toggleGroup.setXMLParam("w","281");
			}
			progGroup.setXMLParam("w","-555");
			progGroup.show();
			
			if ((w - 270) < 281) {
				switcher.getParent().setXMLParam("x","206");
				switcherbase.setXMLParam("x","205");
				switcher.getParent().setXMLParam("relatx","0");
				switcherbase.setXMLParam("relatx","0");
			} else {
				switcher.getParent().setXMLParam("x","-345");
				switcherbase.setXMLParam("x","-346");
				switcher.getParent().setXMLParam("relatx","1");
				switcherbase.setXMLParam("relatx","1");
			}

			switcher.getParent().show();
			switcherbase.show();
		} else { // prioritize prog buttons
			toggleGroup.show();
			toggleGroup.setXMLParam("x",integerToString(-w+270+255-20));
			toggleGroup.setXMLParam("w",integerToString(w-270-255-20));
			if ((w - 265) < 265)
				progGroup.setXMLParam("w","-265");
			else
				progGroup.setXMLParam("w",integerToString(-w+475-205));
			progGroup.show();

			if ((w - 265) < 265) {
				switcher.getParent().setXMLParam("x","-60");
				switcherbase.setXMLParam("x","-60");
				switcher.getParent().setXMLParam("relatx","1");
				switcherbase.setXMLParam("relatx","1");
			} else {
				switcher.getParent().setXMLParam("x","481");
				switcherbase.setXMLParam("x","480");
				switcher.getParent().setXMLParam("relatx","0");
				switcherbase.setXMLParam("relatx","0");
			}
			switcher.getParent().show();
			switcherbase.show();

		}
		if (w <= 300) {  // if minimum width, hide switcher button (useless on this size)
			switcher.getParent().hide();
			switcherbase.hide();
		}
	}
}

switcher.onLeftClick() {
	// reverses private int ;)
	setPrivateInt(getSkinName(), "Prog Or Toggle Priority",!getPrivateInt(getSkinName(), "Prog Or Toggle Priority", 0));
	parentGroup.onResize(parentGroup.getLeft(),parentGroup.getTop(),
						parentGroup.getWidth(),parentGroup.getHeight());
}