/*************************************************************

  KameleonDUI - shade.m
  by Leechbite

  scripts for the shade mode.
  

*************************************************************/

#include <lib/std.mi>
#include "utilities.m"

function refreshGroups();

global layout scriptGroup;

global group groupLCD, groupSHLREP, groupToggle;
global button hideControl, showControl;
global layer SHLREPVertSep;

global boolean noResizeCallback = FALSE;

global timer onLoadDelay;

System.onScriptLoaded() {

	scriptGroup = getScriptGroup();

	groupLCD = scriptGroup.findObject("player.shade.lcd");
	groupSHLREP = scriptGroup.findObject("player.shade.buttons.shfrep");
	groupToggle = scriptGroup.findObject("player.shade.buttons.toggle");
	SHLREPVertSep = groupSHLREP.getObject("sep.ver"); // vertical separator
	
	hideControl = findXUIObject(groupLCD,"contract","xuibutton");
	showControl = findXUIObject(groupLCD,"expand","xuibutton");
	
	onLoadDelay = new Timer;
	onLoadDelay.setDelay(1);
	onLoadDelay.start();
}

System.onScriptUnloading() {
	delete onLoadDelay;
}

onLoadDelay.onTimer() {
	stop();
	refreshGroups();
}

scriptGroup.onResize(int x, int y, int w, int h) {
	if (!scriptGroup.isVisible()) return;
	if (noResizeCallback) return;
	onLoadDelay.start();
}

scriptGroup.onSetVisible(int on) {
	if (on) refreshGroups();
}

refreshGroups() {
	if (!scriptGroup.isVisible()) return;
	
	int mode = getPrivateInt(getSkinName(),"shade control hide status",0);
	int scX = scriptGroup.getLeft();
	int scY = scriptGroup.getTop();
	int scW = scriptGroup.getWidth();
	int scH = scriptGroup.getHeight();
	int newWidth = 0;
	
	if (mode == 0) {
		groupLCD.show();
		if (scW >= 532) groupSHLREP.show();	else groupSHLREP.hide();
		if (scW >= 425) groupToggle.show(); else groupToggle.hide();
		
		groupLCD.setXMLParam("w","-535");
		groupSHLREP.setXMLParam("x","-325");
		groupToggle.setXMLParam("x","-218");
		
		if (scW < 363)	scriptGroup.resize(scX, scY, 300, scH);
		else if (scW < 480) scriptGroup.resize(scX, scY, 425, scH);
		else if (scW < 590) scriptGroup.resize(scX, scY, 545, scH);
		else if (scW < 632) scriptGroup.resize(scX, scY, 632, scH);
	
		hideControl.getParent().show();
		showControl.getParent().hide();
	}
	if (mode == 1) {
		groupLCD.show();
		groupSHLREP.hide();
		groupToggle.show();
		
		if (scW >= 425) groupToggle.show(); else groupToggle.hide();
		
		groupLCD.setXMLParam("w","-430");
		groupToggle.setXMLParam("x","-218");

		if (scW < 363)	scriptGroup.resize(scX, scY, 300, scH);
		else if (scW < 480) scriptGroup.resize(scX, scY, 440, scH);
		else if (scW < 520) scriptGroup.resize(scX, scY, 520, scH);
				
		hideControl.getParent().show();
		showControl.getParent().hide();
	}
	if (mode == 2) {
		groupLCD.show();
		groupSHLREP.hide();
		groupToggle.hide();
		
		groupLCD.setXMLParam("w","-295");
		
		if (scW < 400) { scriptGroup.resize(scX, scY, 300, scH); groupLCD.hide(); }

		hideControl.getParent().hide();
		showControl.getParent().show();
	}
	if (mode == 3) {
		groupLCD.show();
		groupSHLREP.show(); SHLREPVertSep.hide();
		groupToggle.hide();
		
		if (scW >= 395) groupSHLREP.show(); else groupSHLREP.hide();
		
		groupLCD.setXMLParam("w","-395");
		groupSHLREP.setXMLParam("x","-183");

		if (scW < 363)	scriptGroup.resize(scX, scY, 300, scH);
		else if (scW < 450) scriptGroup.resize(scX, scY, 405, scH);
		else if (scW < 490) scriptGroup.resize(scX, scY, 490, scH);
		
		hideControl.getParent().hide();
		showControl.getParent().show();
	} else {
		groupSHLREP.setXMLParam("x","-325");
		SHLREPVertSep.show();
	}
	
}

hideControl.onLeftClick() {
	int mode = getPrivateInt(getSkinName(),"shade control hide status",0);
	
	mode++;
	if (mode > 3) mode = 0;
	
	setPrivateInt(getSkinName(),"shade control hide status",mode);
	refreshGroups();
}

showControl.onLeftClick() {
	int mode = getPrivateInt(getSkinName(),"shade control hide status",0);
	
	mode++;
	if (mode > 3) mode = 0;
	
	setPrivateInt(getSkinName(),"shade control hide status",mode);
	refreshGroups();
}