/*************************************************************

  KameleonDUI - songticker.m
  by Leechbite

  custom songticker scripts. also handles tempText;
  

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"

Global text dummySongticker, songticker, artist;
Global string newTitle, newArtist;

System.onScriptLoaded() {
	initAttribs();
	
	group scriptGroup = getScriptGroup();

	dummySongticker = scriptGroup.getObject("dummy.songticker");
	artist = scriptGroup.getObject("artist");
	songticker = scriptGroup.getObject("songticker");

	songticker_scroll_attrib.onDataChanged();
		
	dummySongticker.onTextChanged(dummySongticker.getText());
}

System.onScriptUnloading() {
	return;
}

songticker_scroll_attrib.onDataChanged() {
	if (artist) artist.setXMLParam("ticker",getData());
	if (songticker) songticker.setXMLParam("ticker",getData());
}

dummySongticker.onTextChanged(string newtxt) {
	newTitle = getPlayItemMetaDataString("title");
	newArtist = getPlayItemMetaDataString("artist");
	
	int newTitleLen = strlen(newTitle);
	
	if (newArtist == "" || newTitleLen > strlen(newtxt)) { 
		newArtist = getToken(newtxt,"-",0);
		newTitle = strright(newtxt, strlen(newtxt)-strsearch(newtxt,"-") - 1);
	}
	
	if (newTitle == "") newTitle = newtxt;
	if (newArtist == "") newArtist = "No Artist";
	
	if (onTempText()) {
		songticker.setText(newTitle);
		artist.setText(newArtist);
	}
}

temptext_attrib.onDataChanged() {
	if (getData() == "") {
		songticker.setText(newTitle);
		artist.setText(newArtist);
	} else {
		songticker.setText(getToken(getData() , "|", 0));
		artist.setText(getToken(getData() , "|", 1));
	}
}

