/*************************************************************

  KameleonDUI - timer2.m
  by Leechbite

  script for sonique2 style advance timer.
  

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

function updateTimer();

Global text dummyTimer, txtTimer;

Global timer timerRefresh;

System.onScriptLoaded() {
	initAttribs();
	
	group scriptGroup = getScriptGroup();

	dummyTimer = scriptGroup.getObject("dummy.timer");
	txtTimer = scriptGroup.getObject("timer");

	updateTimer();
	
	timerRefresh = new Timer;
	timerRefresh.setDelay(50);
	timerRefresh.start();
}

System.onScriptUnloading() {
	return;
}

updateTimer() {
	string newTimer;
	int elapsed;
	
	elapsed = (timer_elapsed_attrib.getData() == "1");
	
	int currPos = getPosition();
	
	if (timer_remain_attrib.getData()=="1") currPos = getPlayItemLength() - currPos;

	if (currPos < 0) { 
		elapsed = 1;
		currPos = getPosition();
	}
		
	int min = currPos / 60000;
	int sec = (currPos % 60000) / 1000;
	int millsec = (currPos % 1000) / 10;
	
	string strMin = integerToString(min);
	if (min < 10) strMin = "0"+strMin;
	if (min < 100) strMin = "0"+strMin;
	
	string strSec = integerToString(sec);
	if (sec < 10) strSec = "0"+strSec;
	
	string strMillsec = integerToString(millsec);
	if (millsec < 10) strMillsec = "0"+strMillsec;
	
	if (timer_style_000_00_00_attrib.getData()=="1")
		newTimer = strMin+":"+strSec+":"+strMillsec;
	else
		newTimer = strMin+":"+strSec;
	
	if (!elapsed) newTimer = "-"+newTimer;
	
	txtTimer.setText(newTimer);
}

dummyTimer.onTextChanged(string newtxt) {
	updateTimer();
}

timerRefresh.onTimer() {
	updateTimer();
}

txtTimer.onRightButtonDown(int x, int y) {
	popupMenu timerMenu;

	string oldToolTip = getXMLParam("tooltip");
	setXMLParam("tooltip", "");
  
	timerMenu = new popupMenu;
	timerMenu.addCommand("- Timer Options -", -1, 0, 1);
	timerMenu.addSeparator();
	timerMenu.addCommand(" 000:00:00", 0, timer_style_000_00_00_attrib.getData()=="1", 0);
	timerMenu.addCommand(" 000:00", 1, timer_style_000_00_attrib.getData()=="1", 0);
	timerMenu.addSeparator();
	timerMenu.addCommand(" Remaining", 2, timer_remain_attrib.getData()=="1", 0);
	timerMenu.addCommand(" Elapsed", 3, timer_elapsed_attrib.getData()=="1", 0);

	int res = timerMenu.popAtMouse();
	delete timerMenu;

	setXMLParam("tooltip", oldToolTip);
	
	if (res<0) return;
	if (res==0) timer_style_000_00_00_attrib.setData("1");
	if (res==1) timer_style_000_00_attrib.setData("1");
	if (res==2) timer_remain_attrib.setData("1");
	if (res==3) timer_elapsed_attrib.setData("1");
  
	complete; 
}

txtTimer.onLeftButtonDown(int x, int y) {
	if (timer_remain_attrib.getData()=="1")
		timer_elapsed_attrib.setData("1");
	else
		timer_remain_attrib.setData("1");
}
