/*************************************************************

  text-abbr.m
  by Leechbite

  script used to abbr the components title if its parent width
  is too small for text to fit.
  
  param = "parentgroupID,textID1,textID2,abbr"

*************************************************************/

#include <lib/std.mi>

Global group parentGroup;
Global text textobj1, textobj2;
Global string abbr, orig;
Global boolean onLoad = true;
Global int origWidth;

System.onScriptLoaded() {

	group scriptGroup = getScriptGroup();
	string param = getParam();
	
	parentGroup = scriptGroup.findObject(getToken(param,",",0));
	textobj1 = parentGroup.getObject(getToken(param,",",1));
	textobj2 = parentGroup.getObject(getToken(param,",",2));
	abbr = getToken(param,",",3);
	if (textobj1) {
		orig = textobj1.getText();
		origWidth = textobj1.getTextWidth();
	}
}

textobj1.onTextChanged(string newtext) {
	if (!onLoad) return;
	if (strleft(newtext,1)!=":") {
		if (newtext != abbr) {
			orig = newtext;
			origWidth = getTextWidth();
			parentGroup.onResize(0, 0, parentGroup.getWidth(), 0);
		}
		onLoad = false;
	}
}

parentGroup.onResize(int x, int y, int w, int h) {
	if (w < origWidth) {
		if (textobj1) textobj1.setText(abbr);
		if (textobj2) textobj2.setText(abbr);
	} else {
		if (textobj1) textobj1.setText(orig);
		if (textobj2) textobj2.setText(orig);
	}
}