/*************************************************************

  KameleonDUI - xui-bkground.m
  by Leechbite

  Kameleon:Background XUI Object Scripts

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

Global group scriptGroup;
Global layer bgImage;
Global guiObject bgColor, bgGroup, bgGradVert, bgGradHort;

System.onScriptLoaded() {
  initAttribs();

  scriptGroup = getScriptGroup();
  bgImage = scriptGroup.getObject("bgimage");
  bgColor = scriptGroup.getObject("bgcolor");
  bgGroup = scriptGroup.getObject("bggroup");
  bgGradVert = scriptGroup.getObject("bggradient.vert");
  bgGradHort = scriptGroup.getObject("bggradient.hort");

  bgColor.setXMLParam("color", getPrivateString(getSkinName(),"Config slider.red","0")+","+
  		getPrivateString(getSkinName(),"Config slider.green","0")+","+
  		getPrivateString(getSkinName(),"Config slider.blue","0"));
  
  bkground_image_attrib.onDataChanged();
  //bkground_image_attrib.setData("GROUP:bkground.group.redflame");
  //bkground_image_attrib.setData("GRADH:255,255,255;255,0,0");
}

System.onScriptUnloading() {
  return;
}

// ****** nasty workaround for winamp's gradient "pink" bug
scriptGroup.onResize(int x, int y, int w, int h) {
	string bkData = strupper(bkground_image_attrib.getData());
	string bkData5 = strLeft(bkData,5);
	
	if ((bkData5=="IMAGE" && config_custom_gradv_attrib.getData()=="1") || bkData5=="GRADV") {
		string strtemp = "", bkDataEntry1 = "", bkDataEntry2 = "";
		
		if (bkData5=="IMAGE") {
			bkDataEntry1 = getPrivateString("KameleonDUI","color1",COLOR1DEF);
			bkDataEntry2 = getPrivateString("KameleonDUI","color2",COLOR2DEF);
		}
		else {
			strtemp = getToken(bkData, ";" ,0);
			if (strtemp!="") bkDataEntry1 = strright(strtemp, strlen(strtemp)-strsearch(strtemp, ":")-1);
			strtemp = getToken(bkData, ";" ,1);
			if (strtemp!="") bkDataEntry2 = strright(strtemp, strlen(strtemp)-strsearch(strtemp, ":")-1);
		}
		
		double ratio = 1;
		
		if (h>0) ratio = (w /h);
				
		if (ratio < 3.7) {
			bgGradVert.setXMLParam("gradient_y2","1.0");
			bgGradVert.setXMLParam("points", "0.0="+bkDataEntry1+",255;1.0="+bkDataEntry2+",255");
		} else {
			ratio = ratio * 0.3;
			bgGradVert.setXMLParam("gradient_y2",floattostring(ratio,2));
			bgGradVert.setXMLParam("points", "0.0="+bkDataEntry1+",255;"+floattostring(1.1/ratio,2)+"="+bkDataEntry2+",255");
		}
			
		
	}
}

bkground_image_attrib.onDataChanged() {
	string bkData = strupper(getData());
	
	string strtemp = "", bkDataEntry1 = "", bkDataEntry2 = "";
	strtemp = getToken(bkData, ";" ,0);
	if (strtemp!="") bkDataEntry1 = strright(strtemp, strlen(strtemp)-strsearch(strtemp, ":")-1);
	strtemp = getToken(bkData, ";" ,1);
	if (strtemp!="") bkDataEntry2 = strright(strtemp, strlen(strtemp)-strsearch(strtemp, ":")-1);

	if (strLeft(bkData,5)=="IMAGE") {
		
		// **** this area added to allow users to set diff color/gradient bkground for semi-transparent images
		if (config_custom_solid_attrib.getData()=="1") {
			if (config_custom_color1_attrib.getData()=="1") {
					bgColor.setXMLParam("color",getPrivateString("KameleonDUI","color1",COLOR1DEF));
				} else {
					bgColor.setXMLParam("color",getPrivateString("KameleonDUI","color2",COLOR2DEF));
				}
				bgGradVert.hide(); bgGradHort.hide();
			} else if (config_custom_gradv_attrib.getData()=="1") {
				bgGradVert.show(); bgGradHort.hide();
				bgGradVert.setXMLParam("points", "0.0="+getPrivateString("KameleonDUI","color1",COLOR1DEF)+",255;1.0="+getPrivateString("KameleonDUI","color2",COLOR2DEF)+",255");
			} else {
				bgGradVert.hide(); bgGradHort.show();
				bgGradHort.setXMLParam("points", "0.0="+getPrivateString("KameleonDUI","color1",COLOR1DEF)+",255;1.0="+getPrivateString("KameleonDUI","color2",COLOR2DEF)+",255");
		}
		// ****

		bgGroup.hide();    bgGroup.setXMLParam("groupid", "");
		bgImage.show();    bgImage.setXMLParam("image", bkDataEntry1);
		if (bkDataEntry2=="") bkDataEntry2="0";
		bgImage.setXMLParam("tile", bkDataEntry2);
	} else if (strLeft(bkData,3)=="RGB") {
		bgGroup.hide();    bgGroup.setXMLParam("groupid", "");
		bgImage.hide();
		bgGradVert.hide(); bgGradHort.hide();
		bgColor.setXMLParam("color", bkDataEntry1);
	} else if (strLeft(bkData,5)=="GRADV") {
		bgGroup.hide();    bgGroup.setXMLParam("groupid", "");
		bgImage.hide();
		bgGradVert.show(); bgGradHort.hide();
		scriptGroup.onResize(0,0,scriptGroup.getWidth(),scriptGroup.getHeight());
		//bgGradVert.setXMLParam("points", "0.0="+bkDataEntry1+",255;1.0="+bkDataEntry2+",255");
	} else if (strLeft(bkData,5)=="GRADH") {
		bgGroup.hide();    bgGroup.setXMLParam("groupid", "");
		bgImage.hide();
		bgGradVert.hide(); bgGradHort.show();
		bgGradHort.setXMLParam("points", "0.0="+bkDataEntry1+",255;1.0="+bkDataEntry2+",255");
	} else if (strLeft(bkData,5)=="GROUP") {
		bgImage.hide();
		bgGroup.show();
		bgGroup.setXMLParam("groupid", bkDataEntry1);
	}
}
