/*************************************************************

  KameleonDUI - xui-blackbutton.m
  by Leechbite

  Kameleon:BlackButton XUI Object Scripts
  
  param:
  
  labelText - duh!
  xuiToolTip - assign tooltips, for some reason the normal tooltip tag
  		is not getting passed on by onSetXUIParam.

*************************************************************/

#include <lib/std.mi>

Global group scriptGroup;
Global button xuibutton;
Global text labeltxt, labeltxtglow;
Global guiObject normalButtonState, downButtonState;

System.onScriptLoaded() {

	scriptGroup = getScriptGroup();
	xuibutton = scriptGroup.getObject("xuibutton");
	normalButtonState = scriptGroup.getObject("xuibutton.normal");
	downButtonState = scriptGroup.getObject("xuibutton.down");
	labeltxt = scriptGroup.getObject("xuibutton.label.text");
	labeltxtglow = scriptGroup.getObject("xuibutton.label.text.glow");
	labeltxtglow.setTargetSpeed(0.5);
	
}

System.onScriptUnloading() {
	return;
}

System.onSetXuiParam(String param, String value) {
	param = system.strlower(param);
	if (param=="labeltext") { 
		labeltxt.setXMLParam("text",value);
		labeltxtglow.setXMLParam("text",value);
	} else if (param=="xuitooltip") {
		xuibutton.setXMLParam("tooltip", value);
	} else 
		xuibutton.setXMLParam(param, value);
}

xuibutton.onLeftButtonDown(int x, int y) {
	labeltxt.setXMLParam("x", "2");
	labeltxt.setXMLParam("y", "2");
	labeltxtglow.setXMLParam("x", "2");
	labeltxtglow.setXMLParam("y", "2");
	labeltxtglow.setTargetx(2);
	labeltxtglow.setTargety(2);
	
	normalButtonState.hide();
	downButtonState.show();

}

xuibutton.onLeftButtonUp(int x, int y) {
	labeltxt.setXMLParam("x", "1");
	labeltxt.setXMLParam("y", "1");
	labeltxtglow.setXMLParam("x", "1");
	labeltxtglow.setXMLParam("y", "1");
	labeltxtglow.setTargetx(1);
	labeltxtglow.setTargety(1);
	
	normalButtonState.show();
	downButtonState.hide();

}

xuibutton.onRightButtonDown(int x, int y) { xuibutton.onLeftButtonDown(x, y); }
xuibutton.onRightButtonUp(int x, int y) { xuibutton.onLeftButtonUp(x, y); }

xuibutton.onEnterArea() {
	labeltxtglow.cancelTarget();
	labeltxtglow.setAlpha(255);
}

xuibutton.onLeaveArea() {
	labeltxtglow.setTargetA(0);
	labeltxtglow.gotoTarget();
}
