/*************************************************************

  KameleonDUI - xui-button.m
  by Leechbite

  Kameleon:Button XUI Object Scripts

*************************************************************/

#include <lib/std.mi>

Global group scriptGroup;
Global button xuibutton;
Global layer label, glow;
Global int labelx = 0, labely = 0;

System.onScriptLoaded() {

  scriptGroup = getScriptGroup();
  xuibutton = scriptGroup.getObject("xuibutton");
  label = scriptGroup.getObject("xuibutton.label");
  glow = scriptGroup.getObject("xuibutton.glow");
  glow.setTargetSpeed(0.5);
}

System.onScriptUnloading() {
  return;
}

System.onSetXuiParam(String param, String value) {
  param = system.strlower(param);
  
  if (param=="labelimage") { label.setXMLParam("image",value); }
  else if (param=="labelx") { label.setXMLParam("x",value); labelx = stringToInteger(value); }
  else if (param=="labely") { label.setXMLParam("y",value); labely = stringTOInteger(value); }
  else if (param=="labelw") { label.setXMLParam("w",value); }
  else if (param=="labelh") { label.setXMLParam("h",value); }
  else if (param=="glowimage") { glow.setXMLParam("image",value); }
  else if (param=="gloww") { glow.setXMLParam("w",value); }
  else if (param=="glowh") { glow.setXMLParam("h",value); }
  else if (param=="xuitooltip") { xuibutton.setXMLParam("tooltip", value); }
  else { xuibutton.setXMLParam(param, value); }

  glow.setXMLParam("x", label.getXMLParam("x"));
  glow.setXMLParam("y", label.getXMLParam("y"));

  labelx = stringToInteger(label.getXMLParam("x"));
  labely = stringToInteger(label.getXMLParam("y"));
}

xuibutton.onLeftButtonDown(int x, int y) {
  label.setXMLParam("x", integerToString(labelx+1));
  label.setXMLParam("y", integerToString(labely+1));
  glow.setXMLParam("x", integerToString(labelx+1));
  glow.setXMLParam("y", integerToString(labely+1));
  glow.setTargetx(labelx+1);
  glow.setTargety(labely+1);

}

xuibutton.onLeftButtonUp(int x, int y) {
  label.setXMLParam("x", integerToString(labelx));
  label.setXMLParam("y", integerToString(labely));
  glow.setXMLParam("x", integerToString(labelx));
  glow.setXMLParam("y", integerToString(labely));
  glow.setTargetx(labelx);
  glow.setTargety(labely);
}

xuibutton.onEnterArea() {
  glow.cancelTarget();
  glow.setAlpha(255);
}

xuibutton.onLeaveArea() {
  glow.setTargetA(0);
  glow.gotoTarget();
}
