/*************************************************************

  xui-cdcover.m
  by Leechbite

  script for Kameleon:CDCover XUI object.

*************************************************************/

#include <lib/std.mi>
#include "attribs.m"
#include "utilities.m"

function updateCDCover();

Global layout cdcoverbrowser;
Global group scriptGroup, parentGroup;
Global layer noCover,cdCover;
Global AlbumArtLayer waCDCover;
//global string last_autotitle = "";


System.onScriptLoaded() {
	initAttribs();
	
	cdcoverbrowser = getContainer("CDCoverBrowser").getLayout("normal");
	
	scriptGroup = getScriptGroup();
	parentGroup = scriptGroup.getParent();
	
	noCover = scriptGroup.getObject("xui.nocover");
	cdCover = scriptGroup.getObject("xui.cdcover");
	waCDCover = scriptGroup.getObject("xui.wa.cdcover");
	
	updateCDCover();
}

system.onScriptUnloading() {
	parentGroup = NULL;
	scriptGroup = NULL;
	noCover = NULL;
	cdCover = NULL;
}

scriptGroup.onResize(int x, int y, int w, int h) {
	float aspectRatio = stringToFloat(cdcover_aspectratio_attrib.getData());
	if (aspectRatio <= 0) aspectRatio = 1;
	
	int imgw = w, imgh = h;
	
	if (cdcover_size_1x_attrib.getData()=="1" && cdcover_coverfname_attrib.getData()!="blank") {
		if (cdcover_coverfname_attrib.getData()!="def") {
			imgw = cdCover.getAutoWidth();
			imgh = cdCover.getAutoHeight();
		} else {
			imgw = waCDCover.getAutoWidth();
			imgh = waCDCover.getAutoHeight();
		}
	} else if (cdcover_size_custom_attrib.getData()=="1") {
		imgw = stringToInteger(cdcover_size_custom_pix_attrib.getData());
		if (imgw < 50) imgw = 50;
		imgh = imgw/aspectRatio;
	}
	
	if (imgw>w) { imgw = w; imgh = w/aspectRatio; }
	if (imgh>h) { imgh = h; imgw = h*aspectRatio; }

	int sizew = imgw;
	int sizeh = sizew/aspectRatio;
	
	if (sizeh > h) {
		sizeh = imgh;
		sizew = sizeh*aspectRatio;
	}
	
	int nx = (w-sizew)/2;
	int ny = (h-sizeh)/2;
	
	string strSizew = integerToString(sizew);
	string strSizeh = integerToString(sizeh);
	string strnx = integerToString(nx);
	string strny = integerToString(ny);
	
	setPrivateInt("KameleonDUI","nocdupdate",1);
	if (cdcover_coverfname_attrib.getData()!="def") {
		cdCover.setXMLParam("w",strSizew);
		cdCover.setXMLParam("h",strSizeh);
		cdCover.setXMLParam("x", integerToString(nx));
		setPrivateInt("KameleonDUI","nocdupdate",0);
		cdCover.setXMLParam("y", integerToString(ny));
	} else {
		cdCover.setXMLParam("w",strSizew);
		cdCover.setXMLParam("h",strSizeh);
		waCDCover.setXMLParam("w",strSizew);
		waCDCover.setXMLParam("h",strSizeh);
		waCDCover.setXMLParam("x", integerToString(nx));
		setPrivateInt("KameleonDUI","nocdupdate",0);
		waCDCover.setXMLParam("y", integerToString(ny));
	}
	
	int cdw = noCover.getAutoWidth();
	int cdh = noCover.getAutoHeight();
	
	if (cdw <= 60) cdw = 63;
	if (cdh <= 60) cdh = 63;
	
	float aspectRatioNC = cdw/cdh;
	if (aspectRatioNC <= 0) aspectRatioNC = 1;
	
	if (cdw > sizew) { cdw = sizew; cdh = sizew/aspectRatioNC; }
	if (cdh > sizeh) { cdw = sizeh*aspectRatioNC; cdh = sizeh; }

	nx = (w-cdw)/2;
	ny = (h-cdh)/2;
	
	noCover.setXMLParam("w",integerToString(cdw));
	noCover.setXMLParam("h",integerToString(cdh));
	noCover.setXMLParam("x", integerToString(nx));
	noCover.setXMLParam("y", integerToString(ny));

}

parentGroup.onSetVisible(int on) {
	if (on) {
		if (scriptGroup.isVisible())
			cdcover_refresh_attrib.setData("1");
	}
}


system.onTitleChange(string newtitle) {
	//if (last_autotitle == newtitle) return;
	if (StrLeft(newtitle, 1) == "[") {
		if (StrLeft(newtitle, 7) == "[Buffer" || StrLeft(newtitle, 4) == "[ICY") return;
	}
	//last_autotitle = newtitle;
	if (waCDCover.isVisible()) waCDCover.hide();
	if (scriptGroup.isVisible()) setPrivateInt(getSkinName(),"cd cover request",1);
}

system.onPlay() {
	if (scriptGroup.isVisible()) setPrivateInt(getSkinName(),"cd cover request",1);
}

system.onResume() {
	if (scriptGroup.isVisible()) setPrivateInt(getSkinName(),"cd cover request",1);
}

cdcover_size_1x_attrib.onDataChanged() {
	if (getData()=="0") return;
	setPrivateInt("KameleonDUI","nocdupdate",0);
	scriptGroup.onResize(scriptGroup.getLeft(),scriptGroup.getTop(), scriptGroup.getWidth(),scriptGroup.getHeight());
}

cdcover_size_full_attrib.onDataChanged() {
	if (getData()=="0") return;
	setPrivateInt("KameleonDUI","nocdupdate",0);
	scriptGroup.onResize(scriptGroup.getLeft(),scriptGroup.getTop(), scriptGroup.getWidth(),scriptGroup.getHeight());
}

cdcover_size_custom_attrib.onDataChanged() {
	if (getData()=="0") return;
	setPrivateInt("KameleonDUI","nocdupdate",0);
	scriptGroup.onResize(scriptGroup.getLeft(),scriptGroup.getTop(), scriptGroup.getWidth(),scriptGroup.getHeight());
}

cdcover_size_custom_pix_attrib.onDataChanged() {
	setPrivateInt("KameleonDUI","nocdupdate",0);
	scriptGroup.onResize(scriptGroup.getLeft(),scriptGroup.getTop(),
						scriptGroup.getWidth(),scriptGroup.getHeight());
}

cdcover_coverfname_attrib.onDataChanged() {
	if (getData()=="def") {
		waCDCover.show();
		cdCover.hide();
		
		waCDCover.refresh();
	} else {
		cdCover.setXMLParam("image",getData());
		cdCover.show();
		waCDCover.hide();
	}
	
	scriptGroup.onResize(scriptGroup.getLeft(),scriptGroup.getTop(),
								scriptGroup.getWidth(),scriptGroup.getHeight());
}

cdcover_mediatype_attrib.onDataChanged() {
	string mediatype = cdcover_mediatype_attrib.getData();
		
	if (mediatype=="itv") noCover.setXMLParam("image","cdcover.local.itv");
	else if (mediatype=="vid" || mediatype=="mov") noCover.setXMLParam("image","cdcover.local.vid");
	else if (mediatype=="iradio") noCover.setXMLParam("image","cdcover.local.shoutcast");
	else noCover.setXMLParam("image","cdcover.local.audio");
	
	scriptGroup.onResize(scriptGroup.getLeft(),scriptGroup.getTop(),
								scriptGroup.getWidth(),scriptGroup.getHeight());
}

updateCDCover() {
	if (!scriptGroup.isVisible()) return;
	if (!cdcoverbrowser.isVisible()) cdcoverbrowser.show();
	
	cdcover_mediatype_attrib.onDataChanged();
	cdcover_coverfname_attrib.onDataChanged();
}

cdCover.onRightButtonDown(int x, int y) {
	cdcover_menu_attrib.setData("1");
}

waCDcover.onRightButtonDown(int x, int y) {
	cdcover_menu_attrib.setData("1");
}