/*************************************************************

  xui-cdcoverbrowser.m
  by Leechbite

  cover fetch script for Kameleon:CDCover XUI object.

*************************************************************/

#include <lib/std.mi>
#include <lib/fileio.mi>
#include <lib/application.mi>
#include "attribs.m"
#include "utilities.m"

function updateCDCover();
function int updateLocal();
function updateRemote();
function int notonskiplist();

Global group scriptGroup;
Global browser cdbrowser;
Global AlbumArtLayer waCDCover;

Global String strSkinHTMLPath, mediatype;
Global boolean localfound = false;
Global string lastlocal = "";
global timer checkNoCDVisible, onLoadTimer, loadCoverDelay;
global int noRequest = FALSE, onDownload = FALSE;

global string lastDownloadPath, coverURL, coverfname;

System.onScriptLoaded() {
	initAttribs();
	
	scriptGroup = getScriptGroup();
	
	waCDCover = scriptGroup.getObject("wa.cdcover");
	cdbrowser = scriptGroup.getObject("xui.browser.cdcover");
	strSkinHTMLPath = System.getParam();
	
	lastDownloadPath = System.getDownloadPath();
	
	cdcover_cdstatus_attrib.setData("");
	
	checkNoCDVisible = new Timer;
	checkNoCDVisible.setDelay(100);
	
	onLoadTimer = new Timer;
	onLoadTimer.setDelay(2000);
	onLoadTimer.start();
	
	loadCoverDelay = new Timer;
	loadCoverDelay.setDelay(300);

	coverURL = "blank";
}



system.onScriptUnloading() {
	delete checkNoCDVisible;
	delete onLoadTimer;
	delete loadCoverDelay;
	scriptGroup = NULL;
	cdbrowser = NULL;
}

onLoadTimer.onTimer() {
	stop();
	
	updateCDCover();
	
}

system.onTitleChange(string newtitle) {
	//if (last_autotitle == newtitle) return;
	if (StrLeft(newtitle, 1) == "[") {
		if (StrLeft(newtitle, 7) == "[Buffer" || StrLeft(newtitle, 4) == "[ICY") return;
	}
	//last_autotitle = newtitle;
	
	noRequest = FALSE;
	
	checkNoCDVisible.start();
}

checkNoCDVisible.onTimer() {
	stop();
	
	if (getPrivateInt(getSkinName(),"cd cover request",0) == 1)
		updateCDCover();
	else {
		noRequest = TRUE;
		if (cdbrowser) cdbrowser.hide();
	}
	setPrivateInt(getSkinName(),"cd cover request",0);
}

system.onStop() {
	if (cdbrowser) cdbrowser.hide();
}

cdcover_refresh_attrib.onDataChanged() {
	updateCDCover();
}

cdcover_getcdcover_attrib.onDataChanged() {
	if (getAlbumArt(system.getPlayItemString()) > 0) {
		cdcover_coverfname_attrib.setData("blank");
		updateCDCover();
	}
}


cdcover_autodownload_attrib.onDataChanged() {
	if (getData()=="1") 
		updateCDCover();
}

cdcover_getamazoncover_attrib.onDataChanged() {
	updateRemote();
}

cdcover_size_custom_pix_attrib.onDataChanged() {
	if (cdcover_size_custom_attrib.getData()=="0") cdcover_size_custom_attrib.setData("1");
}

cdcover_menu_attrib.onDataChanged() {
	if (getData()=="0") return;
	
	popupMenu CDMenu = new popupMenu;

	CDMenu.addCommand(" Refresh CD Cover", 0, 0, 0);
	CDMenu.addCommand(" Get CD Cover", 10, 0, 0);
	CDMenu.addCommand(" Get Amazon.com CD Cover", 20, 0, 0);
	CDMenu.addSeparator();
	CDMenu.addCommand(" Auto-download (Amazon.com)", 30, cdcover_autodownload_attrib.getData()=="1", 0);
	CDMenu.addSeparator();
	CDMenu.addCommand(" Cover Size: 1x", 31, cdcover_size_1x_attrib.getData()=="1", 0);
	CDMenu.addCommand(" Cover Size: Full", 32, cdcover_size_full_attrib.getData()=="1", 0);
	CDMenu.addCommand(" Cover Size: Custom", 33, cdcover_size_custom_attrib.getData()=="1", 0);
	CDMenu.addSeparator();
	CDMenu.addCommand(" View file info", 38, 0, 0);
	CDMenu.addCommand(" Open folder", 39, 0, 0);
	CDMenu.addSeparator();
	CDMenu.addCommand(" More Artist/Album Info", 40, 0, 0);
	CDMenu.addCommand(" Search Song Lyrics", 50, 0, 0);
	CDMenu.addCommand(" Search Song Chords", 60, 0, 0);
	CDMenu.addCommand(" Artist Official Site", 70, 0, 0);
	
	int res = CDMenu.popAtMouse();
	delete CDMenu;
	
	if (res == 0) updateCDCover();
	else if (res == 10)	cdcover_getcdcover_attrib.onDataChanged();
	else if (res == 20)	cdcover_getamazoncover_attrib.onDataChanged();
	else if (res == 30)	cdcover_autodownload_attrib.setData(integerToString(cdcover_autodownload_attrib.getData()=="0"));
	else if (res == 31) cdcover_size_1x_attrib.setData("1");
	else if (res == 32) cdcover_size_full_attrib.setData("1");
	else if (res == 33) cdcover_size_custom_attrib.setData("1");
	else if (res == 38)	triggerAction(scriptGroup,"trackinfo","");
	else if (res == 39)	navigateUrl(getPath(getPlayItemMetaDataString("filename")));
	else if (res == 40)	inetbrowser_openpage_attrib.setData("moreinfo");
	else if (res == 50) inetbrowser_openpage_attrib.setData("lyrics");
	else if (res == 60) inetbrowser_openpage_attrib.setData("chords");
	else if (res == 70) inetbrowser_openpage_attrib.setData("officialsite");
	
	complete;
	
	setData("0");
}

updateCDCover() {
	if (cdbrowser) cdbrowser.stop();
	cdcover_cdstatus_attrib.setData("");
	
	if (onLoadTimer.isRunning()) return;
	cdcover_coverfname_attrib.setData("blank");

	mediatype = "aud";

	boolean isStream = (StrLeft(getPlayItemString(), 7) == "http://") || (StrLeft(getPlayItemString(), 6) == "mms://");

	if (isVideo()) {
		if (isStream) 
			mediatype = "itv";
		else {
			if (getPlayItemLength() > 120000) // if length is greater than 20min, assume content is a movie
				mediatype = "mov";
			else
				mediatype = "vid";
			
		}
	} else {
		if (isStream) 
			mediatype = "iradio";
		else
			mediatype = "aud";
	}
	
	cdcover_mediatype_attrib.setData(mediatype);
	
	if (cdcover_autodownload_attrib.getData()!="1") cdbrowser.hide();
	
	waCDCover.refresh();
	if (waCDCover.isInvalid()) {
		if (!updateLocal()) {
			if (cdcover_autodownload_attrib.getData()=="1" && notonskiplist()) updateRemote();
		}
	} else {
		int imgw = waCDCover.getAutoWidth();
		int imgh = waCDCover.getAutoHeight();
		if ((imgw>0) && (imgh>0))
			cdcover_aspectratio_attrib.setData(floatTostring(imgw/imgh,10));
		else
			cdcover_aspectratio_attrib.setData("1.0");
		cdcover_coverfname_attrib.setData("def");
	}

}

int notonskiplist() {
	String strAlbum = strlower(System.getPlayitemMetaDataString("album"));
	
	if (strAlbum == "") return 0;
	
	string skiplist = getPrivateString("KameleonDUI","CDCover SkipAlbumNames","unknown,unknown album,album,no title");
	
	string curr = "", ch = "", all = "";
	int c,sstart = 1,d; 
	
	for (c=0; c<strlen(skiplist); c++) {
		ch = strlower(strmid(skiplist,c,1));
		if (ch != "," && ch != ";") {
			if (ch != " " || !sstart) {
				curr = curr + ch;
				sstart = 0;
			}
			
		} else {
			sstart = 1;
			while (strmid(curr,strlen(curr)-1,1)==" " && curr != "") {
				curr = strleft(curr,strlen(curr)-1);
			}
			if (curr == strAlbum) return 0;
			curr = "";
			
		}
		
	}
	if (curr == strAlbum) return 0;
	//all = all + "-" + curr;
	//cdcover_cdstatus_attrib.setData(all+"hey");
	
	return 1;
}

int updateLocal() {

	int localfound;
	String strAlbum = System.getPlayitemMetaDataString("album");
	string fname1 = validateFileName(strAlbum,"/\?*:|\"<>","--__-_'()"); 	// this is for winamp's default cover downloader
	string fname2 = validateFileName(strAlbum,"/\?%*:|\"<>","--_---_'()");	// this is for amazon downloader, some char cannot be used for download
	string filenames = "cover.jpg|coverart.jpg|folder.jpg|front.jpg|cover.png|coverart.png|folder.png|front.png";

	if (strAlbum!="") filenames = fname1+".jpg|"+fname1+".png|"+fname2+".jpg|"+fname2+".png|"+filenames;
		
	string mediaPath = System.getPlayItemString();
	int isCD = strupper(strleft(mediaPath,4)) == "CDA:";
		
	if (!isCD) {
		mediaPath = getPath(mediaPath);
		mediaPath = strRight(mediaPath, strLen(mediaPath) - (strSearch(mediaPath, "//") + 2));
	} else {
		mediaPath = Application.GetSettingsPath()+"\CDAlbumArt";
	}

	int ctr = 0, imgw, imgh;
	localfound = false;
	
	map fileload = new Map;
	file filecheck = new File;
	
	string currFileName = getToken(filenames, "|", ctr);
	
	cdcover_aspectratio_attrib.setData("1.0");
	
	while ((currFileName!="") && (!localfound)) {
		
		filecheck.load(mediaPath+chr(92)+currFileName);
		localfound = filecheck.exists();
		if (!localfound) {
			ctr++;
			currFileName = getToken(filenames, "|", ctr);
		} else {
			fileload.loadMap(mediaPath+chr(92)+currFileName);
			imgw = fileload.getWidth();
			imgh = fileload.getHeight();
			if ((imgw>0) && (imgh>0))
				cdcover_aspectratio_attrib.setData(floatTostring(imgw/imgh,10));
			else
				cdcover_aspectratio_attrib.setData("1.0");
		}
	}
	
	delete fileload;
	delete filecheck;
	
	if (localfound) {
		cdcover_coverfname_attrib.setData(mediaPath+chr(92)+currFileName);
	} else
		cdcover_coverfname_attrib.setData("blank");
		
	lastlocal = cdcover_coverfname_attrib.getData();
	return localfound;
}

updateRemote() {
	
	string mediatype = cdcover_mediatype_attrib.getData();
	if (mediatype=="itv" || mediatype=="iradio") return;
	
	String strQuery = "";
	String strArtist = System.getPlayitemMetaDataString("artist");
	String strAlbum = System.getPlayitemMetaDataString("album");
	String strTitle = System.getPlayitemMetaDataString("title");
	
	if (strArtist != "") strQuery += strArtist + " ";

	if ((strAlbum != "") && (mediatype != "mov")) {
		strQuery += strAlbum;
	} else	{
		strQuery += strTitle;
	}
	if (strQuery=="") strQuery = getPlayItemDisplayTitle();
	
	if (!cdbrowser.isVisible()) cdbrowser.show();
	
	if (cdbrowser) {
		cdbrowser.navigateURL(strSkinHTMLPath + "?" + mediatype + "&"+System.urlEncode(strQuery));
		cdcover_cdstatus_attrib.setData("searching...");
	}

	cdcover_aspectratio_attrib.setData("1.0");
	cdcover_coverfname_attrib.setData("blank");
	
}

cdBrowser.onDocumentComplete(string url) {

	if (onLoadTimer.isRunning()) return;

	int coverw, coverh;
	
	string urlparam = getToken(url,"?",1);

	if (strupper(urlparam)=="NOTFOUND") {
		cdcover_coverfname_attrib.setData(lastlocal);
		cdcover_cdstatus_attrib.setData("");
	} else if (strsearch(strupper(url),"DUMMY.MAKI") > 0) {

		
		coverURL = urlDecode(getURLData(urlparam,"big"));
		
		string ext = strupper(strleft(getExtension(coverURL),2));
		
		if ((ext != "JP") && (ext != "PN")) { // checks if file is JPG, JPEG or PNG, otherwise use medium size
			coverURL = urlDecode(getURLData(urlparam,"med"));
			
			coverw = stringToInteger(getURLData(urlparam,"medw"));
			coverh = stringToInteger(getURLData(urlparam,"medh"));
		} else {
			coverw = stringToInteger(getURLData(urlparam,"bigw"));
			coverh = stringToInteger(getURLData(urlparam,"bigh"));
		}

		if ((coverw <= 0) || (coverh <= 0))
			cdcover_aspectratio_attrib.setData("1.0");
		else {
			cdcover_aspectratio_attrib.setData(floatTostring(coverw/coverh,10));
		}
		
		string mediaPath = System.getPlayItemString();
		int isCD = strupper(strleft(mediaPath,4)) == "CDA:";
		
		if (!isCD) {
			mediaPath = getPath(mediaPath);
			mediaPath = strRight(mediaPath, strLen(mediaPath) - (strSearch(mediaPath, "//") + 2));
		} else {
			mediaPath = Application.GetSettingsPath()+"\CDAlbumArt";
		}
		
		String strAlbum = System.getPlayitemMetaDataString("album");
		String strArtist = System.getPlayitemMetaDataString("artist");
		
		if (strAlbum=="") strAlbum = "cover";
		strAlbum = validateFileName(strAlbum,"/\?%*:|\"<>","--_---_'()");
		
		if (!onDownload){
			cdcover_cdstatus_attrib.setData("downloading cover...");
			onDownload = TRUE;
			downloadMedia(coverURL+"&/"+strAlbum+".jpg", mediaPath, 0, 1);
		} else
			cdcover_coverfname_attrib.setData(coverURL);
	} else {
		cdcover_coverfname_attrib.setData("blank");
	}
}

System.onDownloadFinished(String url, boolean success, String filename) {

	if (!onDownload) return;
	onDownload = FALSE;
	
	if (url=="" || !success) {
		coverfname = coverURL;
	} else
		coverfname = filename;
	loadCoverDelay.start();
}

loadCoverDelay.onTimer() {
	stop();
	
	if (cdcover_coverfname_attrib.getData()!="blank") return;
	
	cdcover_cdstatus_attrib.setData("");
	
	if (coverfname=="") return;
	cdcover_coverfname_attrib.setData(coverfname);
}
