/*************************************************************

  xui-rating.m
  by Leechbite

  script for Kameleon:rating XUI object.

*************************************************************/

#include <lib/std.mi>

function updateRating();

Global group scriptGroup;
Global animatedLayer rating;

Global string last_autotitle = "";
Global int buttonDown = FALSE, tempRating;


System.onScriptLoaded() {
	scriptGroup = getScriptGroup();
	
	rating = scriptGroup.getObject("xui.rating");
	
	updateRating();
}

system.onScriptUnloading() {
	scriptGroup = NULL;
	rating = NULL;
}

system.onTitleChange(string newtitle) {
	if (last_autotitle == newtitle) return;
	if (StrLeft(newtitle, 1) == "[") {
		if (StrLeft(newtitle, 7) == "[Buffer" || StrLeft(newtitle, 4) == "[ICY") return;
	}
	last_autotitle = newtitle;
	
	updateRating();
}

system.onPlay() {
	updateRating();
}

system.onResume() {
	updateRating();
}

updateRating() {
	rating.gotoFrame(getCurrentTrackRating());
}

system.onCurrentTrackRated(int newrating) {
	rating.gotoFrame(newrating);
}

rating.onLeftButtonDown(int x, int y) {
	buttonDown = TRUE;
	
	tempRating = getCurrentTrackRating();
}

rating.onLeftButtonUp(int x, int y) {
	buttonDown = FALSE;
	
	tempRating = ((x-getLeft()) * 5 / getWidth()) + 1;
	if (tempRating > 5) tempRating = 5;
	if (tempRating < 0) tempRating = 0;
	rating.gotoFrame(tempRating);
	setCurrentTrackRating(tempRating);
}

rating.onMouseMove(int x, int y) {
	if (!buttonDown) return;
	
	tempRating = ((x-getLeft()) * 5 / getWidth()) + 1;
	if (tempRating > 5) tempRating = 5;
	if (tempRating < 0) tempRating = 0;
	rating.gotoFrame(tempRating);
}